/**
 * Copyright (C) 2020 Marvin Rösch
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (_isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(n);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o) {
  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) {
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var it,
      normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var regenerator = runtime_1;

/* eslint-disable */

/**
 * Diff Match and Patch
 *
 * Copyright 2006 Google Inc.
 * http://code.google.com/p/google-diff-match-patch/
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Computes the difference between two texts to create a patch.
 * Applies the patch onto another text, allowing for errors.
 * @author fraser@google.com (Neil Fraser)
 */

/**
 * Forked to abstract string handling methods so diff can be run against
 * different data structures, e.g. strings stored as arrays.
 *
 * The following methods have been added:
 * - isEqualChar
 * - isEqualString
 * - charsToString
 * - getEmptyString
 *
 * The following properties have been added:
 * - lastDiffTimedOut
 *
 * @author Ed Sanders
 * https://github.com/edg2s/google-diff-match-patch
 */

/**
 * Included and changed the version by Ed Sanders for further improvements and fixes.
 * Semantic cleanup now works with different representations, too.
 * A bug which would result in not all EQUALS edits to be retained was fixed.
 *
 * The following methods have been added:
 * - matchChar
 * - matchString
 * - indexOf
 *
 * @author Marvin Rösch
 * https://github.com/PaleoCrafter/vuesueal-diff
 */

/**
 * Class containing the diff, match and patch methods.
 * @constructor
 */
function diff_match_patch() {
  // Defaults.
  // Redefine these in your program to override the defaults.
  // Number of seconds to map a diff before giving up (0 for infinity).
  this.Diff_Timeout = 1.0; // Cost of an empty edit operation in terms of edit characters.

  this.Diff_EditCost = 4; // At what point is no match declared (0.0 = perfection, 1.0 = very loose).

  this.Match_Threshold = 0.5; // How far to search for a match (0 = exact location, 1000+ = broad match).
  // A match this many characters away from the expected location will add
  // 1.0 to the score (0.0 is a perfect match).

  this.Match_Distance = 1000; // When deleting a large block of text (over ~64 characters), how close do
  // the contents have to be to match the expected contents. (0.0 = perfection,
  // 1.0 = very loose).  Note that Match_Threshold controls how closely the
  // end points of a delete need to match.

  this.Patch_DeleteThreshold = 0.5; // Chunk size for context length.

  this.Patch_Margin = 4; // The number of bits in an int.

  this.Match_MaxBits = 32;
} //  DIFF FUNCTIONS

/**
 * The data structure representing a diff is an array of tuples:
 * [[DIFF_DELETE, 'Hello'], [DIFF_INSERT, 'Goodbye'], [DIFF_EQUAL, ' world.']]
 * which means: delete 'Hello', add 'Goodbye' and keep ' world.'
 */


var DIFF_DELETE = -1;
var DIFF_INSERT = 1;
var DIFF_EQUAL = 0;

diff_match_patch.prototype.indexOfFrom = function (haystack, needle, startIndex) {
  var slicedIndex = this.indexOf(haystack.slice(startIndex), needle);
  return slicedIndex === -1 ? -1 : startIndex + slicedIndex;
};

diff_match_patch.prototype.indexOf = function (haystack, needle) {
  return haystack.indexOf(needle);
};

diff_match_patch.prototype.isEqualChar = function (a, b) {
  return a === b;
};

diff_match_patch.prototype.isEqualString = function (a, b) {
  return a === b;
};

diff_match_patch.prototype.charsToString = function (chars) {
  return chars.join('');
};

diff_match_patch.prototype.getEmptyString = function () {
  return '';
};

diff_match_patch.prototype.matchChar = function (_char, regex) {
  return _char.match(regex);
};

diff_match_patch.prototype.matchString = function (string, regex) {
  return string.match(regex);
};
/**
 * Find the differences between two texts.  Simplifies the problem by stripping
 * any common prefix or suffix off the texts before diffing.
 * @param {string} text1 Old string to be diffed.
 * @param {string} text2 New string to be diffed.
 * @param {Object} options Optional parameters
 *  - {boolean} checklines Optional speedup flag. If present and false,
 *     then don't run a line-level diff first to identify the changed areas.
 *     Defaults to true, which does a faster, slightly less optimal diff.
 *  - {number} deadline Optional time when the diff should be complete
 *     by.  Used internally for recursive calls.  Users should set DiffTimeout
 *     instead.
 *  - {boolean} keepOldText Where the text1 and text2 are "equal", keep text1.
 *    Since it is possible to override isEqualString, the text may be "equal"
 *    but not exactly the same.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 */


diff_match_patch.prototype.diff_main = function (text1, text2, options) {
  var opt_checklines, opt_deadline, keepText;
  this.lastDiffTimedOut = false;

  if (_typeof(options) === 'object') {
    opt_checklines = options.checklines, opt_deadline = options.deadline, keepText = options.keepOldText ? text1 : text2;
  } else {
    // Backwards compatiblity with old function signature: (text1, text, opt_checklines, opt_deadline)
    opt_checklines = arguments[2];
    opt_deadline = arguments[3];
    keepText = text2;
  } // Set a deadline by which time the diff must be complete.


  if (typeof opt_deadline === 'undefined') {
    if (this.Diff_Timeout <= 0) {
      opt_deadline = Number.MAX_VALUE;
    } else {
      opt_deadline = new Date().getTime() + this.Diff_Timeout * 1000;
    }
  }

  var deadline = opt_deadline; // Check for null inputs.

  if (text1 === null || text2 === null) {
    throw new Error('Null input. (diff_main)');
  } // Check for equality (speedup).


  if (this.isEqualString(text1, text2)) {
    if (keepText) {
      return [[DIFF_EQUAL, keepText]];
    }

    return [];
  }

  if (typeof opt_checklines === 'undefined') {
    opt_checklines = true;
  }

  var checklines = opt_checklines; // Trim off common prefix (speedup).

  var commonlength = this.diff_commonPrefix(text1, text2);
  var commonprefix = keepText.slice(0, commonlength);
  text1 = text1.slice(commonlength);
  text2 = text2.slice(commonlength); // Trim off common suffix (speedup).

  commonlength = this.diff_commonSuffix(text1, text2);
  var commonsuffix = keepText.slice(keepText.length - commonlength);
  text1 = text1.slice(0, text1.length - commonlength);
  text2 = text2.slice(0, text2.length - commonlength); // Compute the diff on the middle block.

  var diffs = this.diff_compute_(text1, text2, checklines, deadline); // Restore the prefix and suffix.

  if (commonprefix) {
    diffs.unshift([DIFF_EQUAL, commonprefix]);
  }

  if (commonsuffix) {
    diffs.push([DIFF_EQUAL, commonsuffix]);
  }

  this.diff_cleanupMerge(diffs);
  return diffs;
};
/**
 * Find the differences between two texts.  Assumes that the texts do not
 * have any common prefix or suffix.
 * @param {string} text1 Old string to be diffed.
 * @param {string} text2 New string to be diffed.
 * @param {boolean} checklines Speedup flag.  If false, then don't run a
 *     line-level diff first to identify the changed areas.
 *     If true, then run a faster, slightly less optimal diff.
 * @param {number} deadline Time when the diff should be complete by.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 * @private
 */


diff_match_patch.prototype.diff_compute_ = function (text1, text2, checklines, deadline) {
  var diffs;

  if (!text1) {
    // Just add some text (speedup).
    return [[DIFF_INSERT, text2]];
  }

  if (!text2) {
    // Just delete some text (speedup).
    return [[DIFF_DELETE, text1]];
  }

  var longtext = text1.length > text2.length ? text1 : text2;
  var shorttext = text1.length > text2.length ? text2 : text1;
  var i = this.indexOf(longtext, shorttext);

  if (i !== -1) {
    // Shorter text is inside the longer text (speedup).
    diffs = [[DIFF_INSERT, longtext.slice(0, i)], [DIFF_EQUAL, shorttext], [DIFF_INSERT, longtext.slice(i + shorttext.length)]]; // Swap insertions for deletions if diff is reversed.

    if (text1.length > text2.length) {
      diffs[0][0] = diffs[2][0] = DIFF_DELETE;
    }

    return diffs;
  }

  if (shorttext.length === 1) {
    // Single character string.
    // After the previous speedup, the character can't be an equality.
    return [[DIFF_DELETE, text1], [DIFF_INSERT, text2]];
  } // Check to see if the problem can be split in two.


  var hm = this.diff_halfMatch_(text1, text2);

  if (hm) {
    // A half-match was found, sort out the return data.
    var text1_a = hm[0];
    var text1_b = hm[1];
    var text2_a = hm[2];
    var text2_b = hm[3];
    var mid_common = hm[4]; // Send both pairs off for separate processing.

    var diffs_a = this.diff_main(text1_a, text2_a, {
      checklines: checklines,
      deadline: deadline
    });
    var diffs_b = this.diff_main(text1_b, text2_b, {
      checklines: checklines,
      deadline: deadline
    }); // Merge the results.

    return diffs_a.concat([[DIFF_EQUAL, mid_common]], diffs_b);
  }

  if (checklines && text1.length > 100 && text2.length > 100) {
    return this.diff_lineMode_(text1, text2, deadline);
  }

  return this.diff_bisect_(text1, text2, deadline);
};
/**
 * Do a quick line-level diff on both strings, then rediff the parts for
 * greater accuracy.
 * This speedup can produce non-minimal diffs.
 * @param {string} text1 Old string to be diffed.
 * @param {string} text2 New string to be diffed.
 * @param {number} deadline Time when the diff should be complete by.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 * @private
 */


diff_match_patch.prototype.diff_lineMode_ = function (text1, text2, deadline) {
  // Scan the text on a line-by-line basis first.
  var a = this.diff_linesToChars_(text1, text2);
  text1 = a.chars1;
  text2 = a.chars2;
  var linearray = a.lineArray;
  var diffs = this.diff_main(text1, text2, {
    checklines: false,
    deadline: deadline
  }); // Convert the diff back to original text.

  this.diff_charsToLines_(diffs, linearray); // Eliminate freak matches (e.g. blank lines)

  this.diff_cleanupSemantic(diffs); // Rediff any replacement blocks, this time character-by-character.
  // Add a dummy entry at the end.

  diffs.push([DIFF_EQUAL, this.getEmptyString()]);
  var pointer = 0;
  var count_delete = 0;
  var count_insert = 0;
  var text_delete = this.getEmptyString();
  var text_insert = this.getEmptyString();

  while (pointer < diffs.length) {
    switch (diffs[pointer][0]) {
      case DIFF_INSERT:
        count_insert++;
        text_insert = text_insert.concat(diffs[pointer][1]);
        break;

      case DIFF_DELETE:
        count_delete++;
        text_delete = text_delete.concat(diffs[pointer][1]);
        break;

      case DIFF_EQUAL:
        // Upon reaching an equality, check for prior redundancies.
        if (count_delete >= 1 && count_insert >= 1) {
          // Delete the offending records and add the merged ones.
          diffs.splice(pointer - count_delete - count_insert, count_delete + count_insert);
          pointer = pointer - count_delete - count_insert;
          var a = this.diff_main(text_delete, text_insert, {
            checklines: false,
            deadline: deadline
          });

          for (var j = a.length - 1; j >= 0; j--) {
            diffs.splice(pointer, 0, a[j]);
          }

          pointer = pointer + a.length;
        }

        count_insert = 0;
        count_delete = 0;
        text_delete = this.getEmptyString();
        text_insert = this.getEmptyString();
        break;
    }

    pointer++;
  }

  diffs.pop(); // Remove the dummy entry at the end.

  return diffs;
};
/**
 * Find the 'middle snake' of a diff, split the problem in two
 * and return the recursively constructed diff.
 * See Myers 1986 paper: An O(ND) Difference Algorithm and Its Variations.
 * @param {string} text1 Old string to be diffed.
 * @param {string} text2 New string to be diffed.
 * @param {number} deadline Time at which to bail if not yet complete.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 * @private
 */


diff_match_patch.prototype.diff_bisect_ = function (text1, text2, deadline) {
  // Cache the text lengths to prevent multiple calls.
  var text1_length = text1.length;
  var text2_length = text2.length; // Bitwise version of Math.ceil(x+y/2)

  var max_d = text1_length + text2_length + 1 >> 1;
  var v_offset = max_d;
  var v_length = 2 * max_d;
  var v1 = new Array(v_length);
  var v2 = new Array(v_length); // Setting all elements to -1 is faster in Chrome & Firefox than mixing
  // integers and undefined.

  for (var x = 0; x < v_length; x++) {
    v1[x] = -1;
    v2[x] = -1;
  }

  v1[v_offset + 1] = 0;
  v2[v_offset + 1] = 0;
  var delta = text1_length - text2_length; // If the total number of characters is odd, then the front path will collide
  // with the reverse path.

  var front = delta & 1; // Offsets for start and end of k loop.
  // Prevents mapping of space beyond the grid.

  var k1start = 0;
  var k1end = 0;
  var k2start = 0;
  var k2end = 0;

  for (var d = 0; d < max_d; d++) {
    // Bail out if deadline is reached.
    if (new Date().getTime() > deadline) {
      var diff = [[DIFF_DELETE, text1], [DIFF_INSERT, text2]];
      this.lastDiffTimedOut = true;
      return diff;
    } // Walk the front path one step.


    for (var k1 = -d + k1start; k1 <= d - k1end; k1 += 2) {
      var k1_offset = v_offset + k1;
      var x1;

      if (k1 === -d || k1 !== d && v1[k1_offset - 1] < v1[k1_offset + 1]) {
        x1 = v1[k1_offset + 1];
      } else {
        x1 = v1[k1_offset - 1] + 1;
      }

      var y1 = x1 - k1;

      while (x1 < text1_length && y1 < text2_length && this.isEqualChar(text1[x1], text2[y1])) {
        x1++;
        y1++;
      }

      v1[k1_offset] = x1;

      if (x1 > text1_length) {
        // Ran off the right of the graph.
        k1end += 2;
      } else if (y1 > text2_length) {
        // Ran off the bottom of the graph.
        k1start += 2;
      } else if (front) {
        var k2_offset = v_offset + delta - k1;

        if (k2_offset >= 0 && k2_offset < v_length && v2[k2_offset] !== -1) {
          // Mirror x2 onto top-left coordinate system.
          var x2 = text1_length - v2[k2_offset];

          if (x1 >= x2) {
            // Overlap detected.
            return this.diff_bisectSplit_(text1, text2, x1, y1, deadline);
          }
        }
      }
    } // Walk the reverse path one step.


    for (var k2 = -d + k2start; k2 <= d - k2end; k2 += 2) {
      var k2_offset = v_offset + k2;
      var x2;

      if (k2 === -d || k2 !== d && v2[k2_offset - 1] < v2[k2_offset + 1]) {
        x2 = v2[k2_offset + 1];
      } else {
        x2 = v2[k2_offset - 1] + 1;
      }

      var y2 = x2 - k2;

      while (x2 < text1_length && y2 < text2_length && this.isEqualChar(text1[text1_length - x2 - 1], text2[text2_length - y2 - 1])) {
        x2++;
        y2++;
      }

      v2[k2_offset] = x2;

      if (x2 > text1_length) {
        // Ran off the left of the graph.
        k2end += 2;
      } else if (y2 > text2_length) {
        // Ran off the top of the graph.
        k2start += 2;
      } else if (!front) {
        var k1_offset = v_offset + delta - k2;

        if (k1_offset >= 0 && k1_offset < v_length && v1[k1_offset] !== -1) {
          var x1 = v1[k1_offset];
          var y1 = v_offset + x1 - k1_offset; // Mirror x2 onto top-left coordinate system.

          x2 = text1_length - x2;

          if (x1 >= x2) {
            // Overlap detected.
            return this.diff_bisectSplit_(text1, text2, x1, y1, deadline);
          }
        }
      }
    }
  } // Diff took too long and hit the deadline or
  // number of diffs equals number of characters, no commonality at all.


  return [[DIFF_DELETE, text1], [DIFF_INSERT, text2]];
};
/**
 * Given the location of the 'middle snake', split the diff in two parts
 * and recurse.
 * @param {string} text1 Old string to be diffed.
 * @param {string} text2 New string to be diffed.
 * @param {number} x Index of split point in text1.
 * @param {number} y Index of split point in text2.
 * @param {number} deadline Time at which to bail if not yet complete.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 * @private
 */


diff_match_patch.prototype.diff_bisectSplit_ = function (text1, text2, x, y, deadline) {
  var text1a = text1.slice(0, x);
  var text2a = text2.slice(0, y);
  var text1b = text1.slice(x);
  var text2b = text2.slice(y); // Compute both diffs serially.

  var diffs = this.diff_main(text1a, text2a, {
    checklines: false,
    deadline: deadline
  });
  var diffsb = this.diff_main(text1b, text2b, {
    checklines: false,
    deadline: deadline
  });
  return diffs.concat(diffsb);
};
/**
 * Split two texts into an array of strings.  Reduce the texts to a string of
 * hashes where each Unicode character represents one line.
 * @param {string} text1 First string.
 * @param {string} text2 Second string.
 * @return {{chars1: string, chars2: string, lineArray: !Array.<string>}}
 *     An object containing the encoded text1, the encoded text2 and
 *     the array of unique strings.
 *     The zeroth element of the array of unique strings is intentionally blank.
 * @private
 */


diff_match_patch.prototype.diff_linesToChars_ = function (text1, text2) {
  var lineArray = []; // e.g. lineArray[4] === 'Hello\n'

  var lineHash = {}; // e.g. lineHash['Hello\n'] === 4

  var dmp = this; // '\x00' is a valid character, but various debuggers don't like it.
  // So we'll insert a junk entry to avoid generating a null character.

  lineArray[0] = this.getEmptyString();
  /**
   * Split a text into an array of strings.  Reduce the texts to a string of
   * hashes where each Unicode character represents one line.
   * Modifies linearray and linehash through being a closure.
   * @param {string} text String to encode.
   * @return {string} Encoded string.
   * @private
   */

  function diff_linesToCharsMunge_(text) {
    var chars = dmp.getEmptyString(); // Walk the text, pulling out a substring for each line.
    // text.split('\n') would would temporarily double our memory footprint.
    // Modifying text would create many large strings to garbage collect.

    var lineStart = 0;
    var lineEnd = -1; // Keeping our own length variable is faster than looking it up.

    var lineArrayLength = lineArray.length;

    while (lineEnd < text.length - 1) {
      lineEnd = text.indexOf('\n', lineStart);

      if (lineEnd === -1) {
        lineEnd = text.length - 1;
      }

      var line = text.slice(lineStart, lineEnd + 1);
      lineStart = lineEnd + 1;

      if (lineHash.hasOwnProperty(line)) {
        chars = chars.concat(String.fromCharCode(lineHash[line]));
      } else {
        chars = chars.concat(String.fromCharCode(lineArrayLength));
        lineHash[line] = lineArrayLength;
        lineArray[lineArrayLength++] = line;
      }
    }

    return chars;
  }

  var chars1 = diff_linesToCharsMunge_(text1);
  var chars2 = diff_linesToCharsMunge_(text2);
  return {
    chars1: chars1,
    chars2: chars2,
    lineArray: lineArray
  };
};
/**
 * Rehydrate the text in a diff from a string of line hashes to real lines of
 * text.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @param {!Array.<string>} lineArray Array of unique strings.
 * @private
 */


diff_match_patch.prototype.diff_charsToLines_ = function (diffs, lineArray) {
  for (var x = 0; x < diffs.length; x++) {
    var chars = diffs[x][1];
    var text = [];

    for (var y = 0; y < chars.length; y++) {
      text[y] = lineArray[chars[y].charCodeAt(0)];
    }

    var empty = this.getEmptyString();
    diffs[x][1] = empty.concat.apply(empty, text);
  }
};
/**
 * Determine the common prefix of two strings.
 * @param {string} text1 First string.
 * @param {string} text2 Second string.
 * @return {number} The number of characters common to the start of each
 *     string.
 */


diff_match_patch.prototype.diff_commonPrefix = function (text1, text2) {
  // Quick check for common null cases.
  if (!text1 || !text2 || !this.isEqualChar(text1[0], text2[0])) {
    return 0;
  } // Binary search.
  // Performance analysis: http://neil.fraser.name/news/2007/10/09/


  var pointermin = 0;
  var pointermax = Math.min(text1.length, text2.length);
  var pointermid = pointermax;
  var pointerstart = 0;

  while (pointermin < pointermid) {
    if (this.isEqualString(text1.slice(pointerstart, pointermid), text2.slice(pointerstart, pointermid))) {
      pointermin = pointermid;
      pointerstart = pointermin;
    } else {
      pointermax = pointermid;
    } // Bitwise version of Math.floor((a+b)/2)


    pointermid = pointermin + pointermax >> 1;
  }

  return pointermid;
};
/**
 * Determine the common suffix of two strings.
 * @param {string} text1 First string.
 * @param {string} text2 Second string.
 * @return {number} The number of characters common to the end of each string.
 */


diff_match_patch.prototype.diff_commonSuffix = function (text1, text2) {
  // Quick check for common null cases.
  if (!text1 || !text2 || !this.isEqualChar(text1[text1.length - 1], text2[text2.length - 1])) {
    return 0;
  } // Binary search.
  // Performance analysis: http://neil.fraser.name/news/2007/10/09/


  var pointermin = 0;
  var pointermax = Math.min(text1.length, text2.length);
  var pointermid = pointermax;
  var pointerend = 0;

  while (pointermin < pointermid) {
    if (this.isEqualString(text1.slice(text1.length - pointermid, text1.length - pointerend), text2.slice(text2.length - pointermid, text2.length - pointerend))) {
      pointermin = pointermid;
      pointerend = pointermin;
    } else {
      pointermax = pointermid;
    } // Bitwise version of Math.floor((a+b)/2)


    pointermid = pointermin + pointermax >> 1;
  }

  return pointermid;
};
/**
 * Determine if the suffix of one string is the prefix of another.
 * @param {string} text1 First string.
 * @param {string} text2 Second string.
 * @return {number} The number of characters common to the end of the first
 *     string and the start of the second string.
 * @private
 */


diff_match_patch.prototype.diff_commonOverlap_ = function (text1, text2) {
  // Cache the text lengths to prevent multiple calls.
  var text1_length = text1.length;
  var text2_length = text2.length; // Eliminate the null case.

  if (text1_length === 0 || text2_length === 0) {
    return 0;
  } // Truncate the longer string.


  if (text1_length > text2_length) {
    text1 = text1.slice(text1_length - text2_length);
  } else if (text1_length < text2_length) {
    text2 = text2.slice(0, text1_length);
  }

  var text_length = Math.min(text1_length, text2_length); // Quick check for the worst case.

  if (this.isEqualString(text1, text2)) {
    return text_length;
  } // Start by looking for a single character match
  // and increase length until no match is found.
  // Performance analysis: http://neil.fraser.name/news/2010/11/04/


  var best = 0;
  var length = 1;

  while (true) {
    var pattern = text1.slice(text_length - length);
    var found = this.indexOf(text2, pattern);

    if (found === -1) {
      return best;
    }

    length += found;

    if (found === 0 || this.isEqualString(text1.slice(text_length - length), text2.slice(0, length))) {
      best = length;
      length++;
    }
  }
};
/**
 * Do the two texts share a substring which is at least half the length of the
 * longer text?
 * This speedup can produce non-minimal diffs.
 * @param {string} text1 First string.
 * @param {string} text2 Second string.
 * @return {Array.<string>} Five element Array, containing the prefix of
 *     text1, the suffix of text1, the prefix of text2, the suffix of
 *     text2 and the common middle.  Or null if there was no match.
 * @private
 */


diff_match_patch.prototype.diff_halfMatch_ = function (text1, text2) {
  if (this.Diff_Timeout <= 0) {
    // Don't risk returning a non-optimal diff if we have unlimited time.
    return null;
  }

  var longtext = text1.length > text2.length ? text1 : text2;
  var shorttext = text1.length > text2.length ? text2 : text1;

  if (longtext.length < 4 || shorttext.length * 2 < longtext.length) {
    return null; // Pointless.
  }

  var dmp = this; // 'this' becomes 'window' in a closure.

  /**
   * Does a substring of shorttext exist within longtext such that the substring
   * is at least half the length of longtext?
   * Closure, but does not reference any external variables.
   * @param {string} longtext Longer string.
   * @param {string} shorttext Shorter string.
   * @param {number} i Start index of quarter length substring within longtext.
   * @return {Array.<string>} Five element Array, containing the prefix of
   *     longtext, the suffix of longtext, the prefix of shorttext, the suffix
   *     of shorttext and the common middle.  Or null if there was no match.
   * @private
   */

  function diff_halfMatchI_(longtext, shorttext, i) {
    // Start with a 1/4 length substring at position i as a seed.
    // Bitwise version of Math.floor(x/4)
    var seed = longtext.slice(i, i + (longtext.length >> 2));
    var j = -1;
    var best_common = dmp.getEmptyString();
    var best_longtext_a, best_longtext_b, best_shorttext_a, best_shorttext_b;

    while ((j = this.indexOfFrom(shorttext, seed, j + 1)) !== -1) {
      var prefixLength = dmp.diff_commonPrefix(longtext.slice(i), shorttext.slice(j));
      var suffixLength = dmp.diff_commonSuffix(longtext.slice(0, i), shorttext.slice(0, j));

      if (best_common.length < suffixLength + prefixLength) {
        best_common = shorttext.slice(j - suffixLength, j).concat(shorttext.slice(j, j + prefixLength));
        best_longtext_a = longtext.slice(0, i - suffixLength);
        best_longtext_b = longtext.slice(i + prefixLength);
        best_shorttext_a = shorttext.slice(0, j - suffixLength);
        best_shorttext_b = shorttext.slice(j + prefixLength);
      }
    }

    if (best_common.length * 2 >= longtext.length) {
      return [best_longtext_a, best_longtext_b, best_shorttext_a, best_shorttext_b, best_common];
    } else {
      return null;
    }
  } // First check if the second quarter is the seed for a half-match.
  // Bitwise version of Math.ceil(x / 4)


  var hm1 = diff_halfMatchI_(longtext, shorttext, longtext.length + 3 >> 2); // Check again based on the third quarter.
  // Bitwise version of Math.ceil(x / 2)

  var hm2 = diff_halfMatchI_(longtext, shorttext, longtext.length + 1 >> 1);
  var hm;

  if (!hm1 && !hm2) {
    return null;
  } else if (!hm2) {
    hm = hm1;
  } else if (!hm1) {
    hm = hm2;
  } else {
    // Both matched.  Select the longest.
    hm = hm1[4].length > hm2[4].length ? hm1 : hm2;
  } // A half-match was found, sort out the return data.


  var text1_a, text1_b, text2_a, text2_b;

  if (text1.length > text2.length) {
    text1_a = hm[0];
    text1_b = hm[1];
    text2_a = hm[2];
    text2_b = hm[3];
  } else {
    text2_a = hm[0];
    text2_b = hm[1];
    text1_a = hm[2];
    text1_b = hm[3];
  }

  var mid_common = hm[4];
  return [text1_a, text1_b, text2_a, text2_b, mid_common];
};
/**
 * Reduce the number of edits by eliminating semantically trivial equalities.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 */


diff_match_patch.prototype.diff_cleanupSemantic = function (diffs) {
  var changes = false;
  var equalities = []; // Stack of indices where equalities are found.

  var equalitiesLength = 0; // Keeping our own length var is faster in JS.

  /** @type {?string} */

  var lastequality = null; // Always equal to diffs[equalities[equalitiesLength - 1]][1]

  var pointer = 0; // Index of current position.
  // Number of characters that changed prior to the equality.

  var length_insertions1 = 0;
  var length_deletions1 = 0; // Number of characters that changed after the equality.

  var length_insertions2 = 0;
  var length_deletions2 = 0;

  while (pointer < diffs.length) {
    if (diffs[pointer][0] === DIFF_EQUAL) {
      // Equality found.
      equalities[equalitiesLength++] = pointer;
      length_insertions1 = length_insertions2;
      length_deletions1 = length_deletions2;
      length_insertions2 = 0;
      length_deletions2 = 0;
      lastequality = diffs[pointer][1];
    } else {
      // An insertion or deletion.
      if (diffs[pointer][0] === DIFF_INSERT) {
        length_insertions2 += diffs[pointer][1].length;
      } else {
        length_deletions2 += diffs[pointer][1].length;
      } // Eliminate an equality that is smaller or equal to the edits on both
      // sides of it.


      if (lastequality && lastequality.length <= Math.max(length_insertions1, length_deletions1) && lastequality.length <= Math.max(length_insertions2, length_deletions2)) {
        // Duplicate record.
        diffs.splice(equalities[equalitiesLength - 1], 0, [DIFF_DELETE, lastequality]); // Change second copy to insert.

        diffs[equalities[equalitiesLength - 1] + 1][0] = DIFF_INSERT; // Throw away the equality we just deleted.

        equalitiesLength--; // Throw away the previous equality (it needs to be reevaluated).

        equalitiesLength--;
        pointer = equalitiesLength > 0 ? equalities[equalitiesLength - 1] : -1;
        length_insertions1 = 0; // Reset the counters.

        length_deletions1 = 0;
        length_insertions2 = 0;
        length_deletions2 = 0;
        lastequality = null;
        changes = true;
      }
    }

    pointer++;
  } // Normalize the diff.


  if (changes) {
    this.diff_cleanupMerge(diffs);
  }

  this.diff_cleanupSemanticLossless(diffs); // Find any overlaps between deletions and insertions.
  // e.g: <del>abcxxx</del><ins>xxxdef</ins>
  //   -> <del>abc</del>xxx<ins>def</ins>
  // e.g: <del>xxxabc</del><ins>defxxx</ins>
  //   -> <ins>def</ins>xxx<del>abc</del>
  // Only extract an overlap if it is as big as the edit ahead or behind it.

  pointer = 1;

  while (pointer < diffs.length) {
    if (diffs[pointer - 1][0] === DIFF_DELETE && diffs[pointer][0] === DIFF_INSERT) {
      var deletion = diffs[pointer - 1][1];
      var insertion = diffs[pointer][1];
      var overlap_length1 = this.diff_commonOverlap_(deletion, insertion);
      var overlap_length2 = this.diff_commonOverlap_(insertion, deletion);

      if (overlap_length1 >= overlap_length2) {
        if (overlap_length1 >= deletion.length / 2 || overlap_length1 >= insertion.length / 2) {
          // Overlap found.  Insert an equality and trim the surrounding edits.
          diffs.splice(pointer, 0, [DIFF_EQUAL, insertion.slice(0, overlap_length1)]);
          diffs[pointer - 1][1] = deletion.slice(0, deletion.length - overlap_length1);
          diffs[pointer + 1][1] = insertion.slice(overlap_length1);
          pointer++;
        }
      } else {
        if (overlap_length2 >= deletion.length / 2 || overlap_length2 >= insertion.length / 2) {
          // Reverse overlap found.
          // Insert an equality and swap and trim the surrounding edits.
          diffs.splice(pointer, 0, [DIFF_EQUAL, deletion.slice(0, overlap_length2)]);
          diffs[pointer - 1][0] = DIFF_INSERT;
          diffs[pointer - 1][1] = insertion.slice(0, insertion.length - overlap_length2);
          diffs[pointer + 1][0] = DIFF_DELETE;
          diffs[pointer + 1][1] = deletion.slice(overlap_length2);
          pointer++;
        }
      }

      pointer++;
    }

    pointer++;
  }
};
/**
 * Look for single edits surrounded on both sides by equalities
 * which can be shifted sideways to align the edit to a word boundary.
 * e.g: The c<ins>at c</ins>ame. -> The <ins>cat </ins>came.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 */


diff_match_patch.prototype.diff_cleanupSemanticLossless = function (diffs) {
  /**
   * Given two strings, compute a score representing whether the internal
   * boundary falls on logical boundaries.
   * Scores range from 6 (best) to 0 (worst).
   * Closure, but does not reference any external variables.
   * @param {string} one First string.
   * @param {string} two Second string.
   * @return {number} The score.
   * @private
   */
  function diff_cleanupSemanticScore_(one, two) {
    if (!one || !two) {
      // Edges are the best.
      return 6;
    } // Each port of this function behaves slightly differently due to
    // subtle differences in each language's definition of things like
    // 'whitespace'.  Since this function's purpose is largely cosmetic,
    // the choice has been made to use each language's native features
    // rather than force total conformity.


    var char1 = one[one.length - 1];
    var char2 = two[0];
    var nonAlphaNumeric1 = this.matchChar(char1, diff_match_patch.nonAlphaNumericRegex_);
    var nonAlphaNumeric2 = this.matchChar(char2, diff_match_patch.nonAlphaNumericRegex_);
    var whitespace1 = nonAlphaNumeric1 && this.matchChar(char1, diff_match_patch.whitespaceRegex_);
    var whitespace2 = nonAlphaNumeric2 && this.matchChar(char2, diff_match_patch.whitespaceRegex_);
    var lineBreak1 = whitespace1 && this.matchChar(char1, diff_match_patch.linebreakRegex_);
    var lineBreak2 = whitespace2 && this.matchChar(char2, diff_match_patch.linebreakRegex_);
    var blankLine1 = lineBreak1 && this.matchString(one, diff_match_patch.blanklineEndRegex_);
    var blankLine2 = lineBreak2 && this.matchString(two, diff_match_patch.blanklineStartRegex_);

    if (blankLine1 || blankLine2) {
      // Five points for blank lines.
      return 5;
    } else if (lineBreak1 || lineBreak2) {
      // Four points for line breaks.
      return 4;
    } else if (nonAlphaNumeric1 && !whitespace1 && whitespace2) {
      // Three points for end of sentences.
      return 3;
    } else if (whitespace1 || whitespace2) {
      // Two points for whitespace.
      return 2;
    } else if (nonAlphaNumeric1 || nonAlphaNumeric2) {
      // One point for non-alphanumeric.
      return 1;
    }

    return 0;
  }

  diff_cleanupSemanticScore_ = diff_cleanupSemanticScore_.bind(this);
  var pointer = 1; // Intentionally ignore the first and last element (don't need checking).

  while (pointer < diffs.length - 1) {
    if (diffs[pointer - 1][0] === DIFF_EQUAL && diffs[pointer + 1][0] === DIFF_EQUAL) {
      // This is a single edit surrounded by equalities.
      var equality1 = diffs[pointer - 1][1];
      var edit = diffs[pointer][1];
      var equality2 = diffs[pointer + 1][1]; // First, shift the edit as far left as possible.

      var commonOffset = this.diff_commonSuffix(equality1, edit);

      if (commonOffset) {
        var commonString = edit.slice(edit.length - commonOffset);
        equality1 = equality1.slice(0, equality1.length - commonOffset);
        edit = commonString.concat(edit.slice(0, edit.length - commonOffset));
        equality2 = commonString.concat(equality2);
      } // Second, step character by character right, looking for the best fit.


      var bestEquality1 = equality1;
      var bestEdit = edit;
      var bestEquality2 = equality2;
      var bestScore = diff_cleanupSemanticScore_(equality1, edit) + diff_cleanupSemanticScore_(edit, equality2);

      while (this.isEqualChar(edit[0], equality2[0])) {
        equality1 = equality1.concat(edit[0]);
        edit = edit.slice(1).concat(equality2[0]);
        equality2 = equality2.slice(1);
        var score = diff_cleanupSemanticScore_(equality1, edit) + diff_cleanupSemanticScore_(edit, equality2); // The >= encourages trailing rather than leading whitespace on edits.

        if (score >= bestScore) {
          bestScore = score;
          bestEquality1 = equality1;
          bestEdit = edit;
          bestEquality2 = equality2;
        }
      }

      if (!this.isEqualString(diffs[pointer - 1][1], bestEquality1)) {
        // We have an improvement, save it back to the diff.
        if (bestEquality1) {
          diffs[pointer - 1][1] = bestEquality1;
        } else {
          diffs.splice(pointer - 1, 1);
          pointer--;
        }

        diffs[pointer][1] = bestEdit;

        if (bestEquality2) {
          diffs[pointer + 1][1] = bestEquality2;
        } else {
          diffs.splice(pointer + 1, 1);
          pointer--;
        }
      }
    }

    pointer++;
  }
}; // Define some regex patterns for matching boundaries.


diff_match_patch.nonAlphaNumericRegex_ = /[^a-zA-Z0-9]/;
diff_match_patch.whitespaceRegex_ = /\s/;
diff_match_patch.linebreakRegex_ = /[\r\n]/;
diff_match_patch.blanklineEndRegex_ = /\n\r?\n$/;
diff_match_patch.blanklineStartRegex_ = /^\r?\n\r?\n/;
/**
 * Reduce the number of edits by eliminating operationally trivial equalities.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 */

diff_match_patch.prototype.diff_cleanupEfficiency = function (diffs) {
  var changes = false;
  var equalities = []; // Stack of indices where equalities are found.

  var equalitiesLength = 0; // Keeping our own length var is faster in JS.

  /** @type {?string} */

  var lastequality = null; // Always equal to diffs[equalities[equalitiesLength - 1]][1]

  var pointer = 0; // Index of current position.
  // Is there an insertion operation before the last equality.

  var pre_ins = false; // Is there a deletion operation before the last equality.

  var pre_del = false; // Is there an insertion operation after the last equality.

  var post_ins = false; // Is there a deletion operation after the last equality.

  var post_del = false;

  while (pointer < diffs.length) {
    if (diffs[pointer][0] === DIFF_EQUAL) {
      // Equality found.
      if (diffs[pointer][1].length < this.Diff_EditCost && (post_ins || post_del)) {
        // Candidate found.
        equalities[equalitiesLength++] = pointer;
        pre_ins = post_ins;
        pre_del = post_del;
        lastequality = diffs[pointer][1];
      } else {
        // Not a candidate, and can never become one.
        equalitiesLength = 0;
        lastequality = null;
      }

      post_ins = post_del = false;
    } else {
      // An insertion or deletion.
      if (diffs[pointer][0] === DIFF_DELETE) {
        post_del = true;
      } else {
        post_ins = true;
      }
      /*
       * Five types to be split:
       * <ins>A</ins><del>B</del>XY<ins>C</ins><del>D</del>
       * <ins>A</ins>X<ins>C</ins><del>D</del>
       * <ins>A</ins><del>B</del>X<ins>C</ins>
       * <ins>A</del>X<ins>C</ins><del>D</del>
       * <ins>A</ins><del>B</del>X<del>C</del>
       */


      if (lastequality && (pre_ins && pre_del && post_ins && post_del || lastequality.length < this.Diff_EditCost / 2 && pre_ins + pre_del + post_ins + post_del === 3)) {
        // Duplicate record.
        diffs.splice(equalities[equalitiesLength - 1], 0, [DIFF_DELETE, lastequality]); // Change second copy to insert.

        diffs[equalities[equalitiesLength - 1] + 1][0] = DIFF_INSERT;
        equalitiesLength--; // Throw away the equality we just deleted;

        lastequality = null;

        if (pre_ins && pre_del) {
          // No changes made which could affect previous entry, keep going.
          post_ins = post_del = true;
          equalitiesLength = 0;
        } else {
          equalitiesLength--; // Throw away the previous equality.

          pointer = equalitiesLength > 0 ? equalities[equalitiesLength - 1] : -1;
          post_ins = post_del = false;
        }

        changes = true;
      }
    }

    pointer++;
  }

  if (changes) {
    this.diff_cleanupMerge(diffs);
  }
};
/**
 * Reorder and merge like edit sections.  Merge equalities.
 * Any edit section can move as long as it doesn't cross an equality.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 */


diff_match_patch.prototype.diff_cleanupMerge = function (diffs) {
  diffs.push([DIFF_EQUAL, this.getEmptyString()]); // Add a dummy entry at the end.

  var pointer = 0;
  var count_delete = 0;
  var count_insert = 0;
  var text_delete = this.getEmptyString();
  var text_insert = this.getEmptyString();
  var commonlength;

  while (pointer < diffs.length) {
    switch (diffs[pointer][0]) {
      case DIFF_INSERT:
        count_insert++;
        text_insert = text_insert.concat(diffs[pointer][1]);
        pointer++;
        break;

      case DIFF_DELETE:
        count_delete++;
        text_delete = text_delete.concat(diffs[pointer][1]);
        pointer++;
        break;

      case DIFF_EQUAL:
        // Upon reaching an equality, check for prior redundancies.
        if (count_delete + count_insert > 1) {
          if (count_delete !== 0 && count_insert !== 0) {
            // Factor out any common prefixies.
            commonlength = this.diff_commonPrefix(text_insert, text_delete);

            if (commonlength !== 0) {
              if (pointer - count_delete - count_insert > 0 && diffs[pointer - count_delete - count_insert - 1][0] == DIFF_EQUAL) {
                diffs[pointer - count_delete - count_insert - 1][1] = diffs[pointer - count_delete - count_insert - 1][1].concat(text_insert.slice(0, commonlength));
              } else {
                diffs.splice(0, 0, [DIFF_EQUAL, text_insert.slice(0, commonlength)]);
                pointer++;
              }

              text_insert = text_insert.slice(commonlength);
              text_delete = text_delete.slice(commonlength);
            } // Factor out any common suffixies.


            commonlength = this.diff_commonSuffix(text_insert, text_delete);

            if (commonlength !== 0) {
              diffs[pointer][1] = text_insert.slice(text_insert.length - commonlength).concat(diffs[pointer][1]);
              text_insert = text_insert.slice(0, text_insert.length - commonlength);
              text_delete = text_delete.slice(0, text_delete.length - commonlength);
            }
          } // Delete the offending records and add the merged ones.


          if (count_delete === 0) {
            diffs.splice(pointer - count_insert, count_delete + count_insert, [DIFF_INSERT, text_insert]);
          } else if (count_insert === 0) {
            diffs.splice(pointer - count_delete, count_delete + count_insert, [DIFF_DELETE, text_delete]);
          } else {
            diffs.splice(pointer - count_delete - count_insert, count_delete + count_insert, [DIFF_DELETE, text_delete], [DIFF_INSERT, text_insert]);
          }

          pointer = pointer - count_delete - count_insert + (count_delete ? 1 : 0) + (count_insert ? 1 : 0) + 1;
        } else if (pointer !== 0 && diffs[pointer - 1][0] === DIFF_EQUAL) {
          // Merge this equality with the previous one.
          diffs[pointer - 1][1] = diffs[pointer - 1][1].concat(diffs[pointer][1]);
          diffs.splice(pointer, 1);
        } else {
          pointer++;
        }

        count_insert = 0;
        count_delete = 0;
        text_delete = this.getEmptyString();
        text_insert = this.getEmptyString();
        break;
    }
  }

  if (this.isEqualString(diffs[diffs.length - 1][1], this.getEmptyString())) {
    diffs.pop(); // Remove the dummy entry at the end.
  } // Second pass: look for single edits surrounded on both sides by equalities
  // which can be shifted sideways to eliminate an equality.
  // e.g: A<ins>BA</ins>C -> <ins>AB</ins>AC


  var changes = false;
  pointer = 1; // Intentionally ignore the first and last element (don't need checking).

  while (pointer < diffs.length - 1) {
    if (diffs[pointer - 1][0] === DIFF_EQUAL && diffs[pointer + 1][0] === DIFF_EQUAL) {
      // This is a single edit surrounded by equalities.
      if (this.isEqualString(diffs[pointer][1].slice(diffs[pointer][1].length - diffs[pointer - 1][1].length), diffs[pointer - 1][1])) {
        // Shift the edit over the previous equality.
        diffs[pointer][1] = diffs[pointer - 1][1].concat(diffs[pointer][1].slice(0, diffs[pointer][1].length - diffs[pointer - 1][1].length));
        diffs[pointer + 1][1] = diffs[pointer - 1][1].concat(diffs[pointer + 1][1]);
        diffs.splice(pointer - 1, 1);
        changes = true;
      } else if (this.isEqualString(diffs[pointer][1].slice(0, diffs[pointer + 1][1].length), diffs[pointer + 1][1])) {
        // Shift the edit over the next equality.
        diffs[pointer - 1][1] = diffs[pointer - 1][1].concat(diffs[pointer + 1][1]);
        diffs[pointer][1] = diffs[pointer][1].slice(diffs[pointer + 1][1].length).concat(diffs[pointer + 1][1]);
        diffs.splice(pointer + 1, 1);
        changes = true;
      }
    }

    pointer++;
  } // If shifts were made, the diff needs reordering and another shift sweep.


  if (changes) {
    this.diff_cleanupMerge(diffs);
  }
};
/**
 * loc is a location in text1, compute and return the equivalent location in
 * text2.
 * e.g. 'The cat' vs 'The big cat', 1->1, 5->8
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @param {number} loc Location within text1.
 * @return {number} Location within text2.
 */


diff_match_patch.prototype.diff_xIndex = function (diffs, loc) {
  var chars1 = 0;
  var chars2 = 0;
  var last_chars1 = 0;
  var last_chars2 = 0;
  var x;

  for (x = 0; x < diffs.length; x++) {
    if (diffs[x][0] !== DIFF_INSERT) {
      // Equality or deletion.
      chars1 += diffs[x][1].length;
    }

    if (diffs[x][0] !== DIFF_DELETE) {
      // Equality or insertion.
      chars2 += diffs[x][1].length;
    }

    if (chars1 > loc) {
      // Overshot the location.
      break;
    }

    last_chars1 = chars1;
    last_chars2 = chars2;
  } // Was the location was deleted?


  if (diffs.length !== x && diffs[x][0] === DIFF_DELETE) {
    return last_chars2;
  } // Add the remaining character length.


  return last_chars2 + (loc - last_chars1);
};
/**
 * Convert a diff array into a pretty HTML report.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @return {string} HTML representation.
 */


diff_match_patch.prototype.diff_prettyHtml = function (diffs) {
  var html = [];
  var pattern_amp = /&/g;
  var pattern_lt = /</g;
  var pattern_gt = />/g;
  var pattern_para = /\n/g;

  for (var x = 0; x < diffs.length; x++) {
    var op = diffs[x][0]; // Operation (insert, delete, equal)

    var data = diffs[x][1]; // Text of change.

    var text = data.replace(pattern_amp, '&amp;').replace(pattern_lt, '&lt;').replace(pattern_gt, '&gt;').replace(pattern_para, '&para;<br>');

    switch (op) {
      case DIFF_INSERT:
        html[x] = '<ins style="background:#e6ffe6;">' + text + '</ins>';
        break;

      case DIFF_DELETE:
        html[x] = '<del style="background:#ffe6e6;">' + text + '</del>';
        break;

      case DIFF_EQUAL:
        html[x] = '<span>' + text + '</span>';
        break;
    }
  }

  return this.charsToString(html);
};
/**
 * Compute and return the source text (all equalities and deletions).
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @return {string} Source text.
 */


diff_match_patch.prototype.diff_text1 = function (diffs) {
  var text = [];

  for (var x = 0; x < diffs.length; x++) {
    if (diffs[x][0] !== DIFF_INSERT) {
      text[x] = diffs[x][1];
    }
  }

  return this.charsToString(text);
};
/**
 * Compute and return the destination text (all equalities and insertions).
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @return {string} Destination text.
 */


diff_match_patch.prototype.diff_text2 = function (diffs) {
  var text = [];

  for (var x = 0; x < diffs.length; x++) {
    if (diffs[x][0] !== DIFF_DELETE) {
      text[x] = diffs[x][1];
    }
  }

  return this.charsToString(text);
};
/**
 * Compute the Levenshtein distance; the number of inserted, deleted or
 * substituted characters.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @return {number} Number of changes.
 */


diff_match_patch.prototype.diff_levenshtein = function (diffs) {
  var levenshtein = 0;
  var insertions = 0;
  var deletions = 0;

  for (var x = 0; x < diffs.length; x++) {
    var op = diffs[x][0];
    var data = diffs[x][1];

    switch (op) {
      case DIFF_INSERT:
        insertions += data.length;
        break;

      case DIFF_DELETE:
        deletions += data.length;
        break;

      case DIFF_EQUAL:
        // A deletion and an insertion is one substitution.
        levenshtein += Math.max(insertions, deletions);
        insertions = 0;
        deletions = 0;
        break;
    }
  }

  levenshtein += Math.max(insertions, deletions);
  return levenshtein;
};
/**
 * Crush the diff into an encoded string which describes the operations
 * required to transform text1 into text2.
 * E.g. =3\t-2\t+ing  -> Keep 3 chars, delete 2 chars, insert 'ing'.
 * Operations are tab-separated.  Inserted text is escaped using %xx notation.
 * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
 * @return {string} Delta text.
 */


diff_match_patch.prototype.diff_toDelta = function (diffs) {
  var text = [];

  for (var x = 0; x < diffs.length; x++) {
    switch (diffs[x][0]) {
      case DIFF_INSERT:
        text[x] = '+' + encodeURI(diffs[x][1]);
        break;

      case DIFF_DELETE:
        text[x] = '-' + diffs[x][1].length;
        break;

      case DIFF_EQUAL:
        text[x] = '=' + diffs[x][1].length;
        break;
    }
  }

  return text.join('\t').replace(/%20/g, ' ');
};
/**
 * Given the original text1, and an encoded string which describes the
 * operations required to transform text1 into text2, compute the full diff.
 * @param {string} text1 Source string for the diff.
 * @param {string} delta Delta text.
 * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
 * @throws {!Error} If invalid input.
 */


diff_match_patch.prototype.diff_fromDelta = function (text1, delta) {
  var diffs = [];
  var diffsLength = 0; // Keeping our own length var is faster in JS.

  var pointer = 0; // Cursor in text1

  var tokens = delta.split(/\t/g);

  for (var x = 0; x < tokens.length; x++) {
    // Each token begins with a one character parameter which specifies the
    // operation of this token (delete, insert, equality).
    var param = tokens[x].slice(1);

    switch (tokens[x][0]) {
      case '+':
        try {
          diffs[diffsLength++] = [DIFF_INSERT, decodeURI(param)];
        } catch (ex) {
          // Malformed URI sequence.
          throw new Error('Illegal escape in diff_fromDelta: ' + param);
        }

        break;

      case '-': // Fall through.

      case '=':
        var n = parseInt(param, 10);

        if (isNaN(n) || n < 0) {
          throw new Error('Invalid number in diff_fromDelta: ' + param);
        }

        var text = text1.slice(pointer, pointer += n);

        if (tokens[x][0] === '=') {
          diffs[diffsLength++] = [DIFF_EQUAL, text];
        } else {
          diffs[diffsLength++] = [DIFF_DELETE, text];
        }

        break;

      default:
        // Blank tokens are ok (from a trailing \t).
        // Anything else is an error.
        if (tokens[x]) {
          throw new Error('Invalid diff operation in diff_fromDelta: ' + tokens[x]);
        }

    }
  }

  if (pointer !== text1.length) {
    throw new Error('Delta length (' + pointer + ') does not equal source text length (' + text1.length + ').');
  }

  return diffs;
}; //  MATCH FUNCTIONS

/**
 * Locate the best instance of 'pattern' in 'text' near 'loc'.
 * @param {string} text The text to search.
 * @param {string} pattern The pattern to search for.
 * @param {number} loc The location to search around.
 * @return {number} Best match index or -1.
 */


diff_match_patch.prototype.match_main = function (text, pattern, loc) {
  // Check for null inputs.
  if (text === null || pattern === null || loc === null) {
    throw new Error('Null input. (match_main)');
  }

  loc = Math.max(0, Math.min(loc, text.length));

  if (this.isEqualString(text, pattern)) {
    // Shortcut (potentially not guaranteed by the algorithm)
    return 0;
  } else if (!text.length) {
    // Nothing to match.
    return -1;
  } else if (this.isEqualString(text.slice(loc, loc + pattern.length), pattern)) {
    // Perfect match at the perfect spot!  (Includes case of null pattern)
    return loc;
  } else {
    // Do a fuzzy compare.
    return this.match_bitap_(text, pattern, loc);
  }
};
/**
 * Locate the best instance of 'pattern' in 'text' near 'loc' using the
 * Bitap algorithm.
 * @param {string} text The text to search.
 * @param {string} pattern The pattern to search for.
 * @param {number} loc The location to search around.
 * @return {number} Best match index or -1.
 * @private
 */


diff_match_patch.prototype.match_bitap_ = function (text, pattern, loc) {
  if (pattern.length > this.Match_MaxBits) {
    throw new Error('Pattern too long for this browser.');
  } // Initialise the alphabet.


  var s = this.match_alphabet_(pattern);
  var dmp = this; // 'this' becomes 'window' in a closure.

  /**
   * Compute and return the score for a match with e errors and x location.
   * Accesses loc and pattern through being a closure.
   * @param {number} e Number of errors in match.
   * @param {number} x Location of match.
   * @return {number} Overall score for match (0.0 = good, 1.0 = bad).
   * @private
   */

  function match_bitapScore_(e, x) {
    var accuracy = e / pattern.length;
    var proximity = Math.abs(loc - x);

    if (!dmp.Match_Distance) {
      // Dodge divide by zero error.
      return proximity ? 1.0 : accuracy;
    }

    return accuracy + proximity / dmp.Match_Distance;
  } // Highest score beyond which we give up.


  var score_threshold = this.Match_Threshold; // Is there a nearby exact match? (speedup)

  var best_loc = text.indexOf(pattern, loc);

  if (best_loc !== -1) {
    score_threshold = Math.min(match_bitapScore_(0, best_loc), score_threshold); // What about in the other direction? (speedup)

    best_loc = text.lastIndexOf(pattern, loc + pattern.length);

    if (best_loc !== -1) {
      score_threshold = Math.min(match_bitapScore_(0, best_loc), score_threshold);
    }
  } // Initialise the bit arrays.


  var matchmask = 1 << pattern.length - 1;
  best_loc = -1;
  var bin_min, bin_mid;
  var bin_max = pattern.length + text.length;
  var last_rd;

  for (var d = 0; d < pattern.length; d++) {
    // Scan for the best match; each iteration allows for one more error.
    // Run a binary search to determine how far from 'loc' we can stray at this
    // error level.
    bin_min = 0;
    bin_mid = bin_max;

    while (bin_min < bin_mid) {
      if (match_bitapScore_(d, loc + bin_mid) <= score_threshold) {
        bin_min = bin_mid;
      } else {
        bin_max = bin_mid;
      } // Bitwise version of Math.floor((a+b)/2)


      bin_mid = bin_min + bin_max >> 1;
    } // Use the result from this iteration as the maximum for the next.


    bin_max = bin_mid;
    var start = Math.max(1, loc - bin_mid + 1);
    var finish = Math.min(loc + bin_mid, text.length) + pattern.length;
    var rd = Array(finish + 2);
    rd[finish + 1] = (1 << d) - 1;

    for (var j = finish; j >= start; j--) {
      // The alphabet (s) is a sparse hash, so the following line generates
      // warnings.
      var charMatch = s[text[j - 1]] || '';

      if (d === 0) {
        // First pass: exact match.
        rd[j] = (rd[j + 1] << 1 | 1) & charMatch;
      } else {
        // Subsequent passes: fuzzy match.
        rd[j] = (rd[j + 1] << 1 | 1) & charMatch | ((last_rd[j + 1] | last_rd[j]) << 1 | 1) | last_rd[j + 1];
      }

      if (rd[j] & matchmask) {
        var score = match_bitapScore_(d, j - 1); // This match will almost certainly be better than any existing match.
        // But check anyway.

        if (score <= score_threshold) {
          // Told you so.
          score_threshold = score;
          best_loc = j - 1;

          if (best_loc > loc) {
            // When passing loc, don't exceed our current distance from loc.
            start = Math.max(1, 2 * loc - best_loc);
          } else {
            // Already passed loc, downhill from here on in.
            break;
          }
        }
      }
    } // No hope for a (better) match at greater error levels.


    if (match_bitapScore_(d + 1, loc) > score_threshold) {
      break;
    }

    last_rd = rd;
  }

  return best_loc;
};
/**
 * Initialise the alphabet for the Bitap algorithm.
 * @param {string} pattern The text to encode.
 * @return {!Object} Hash of character locations.
 * @private
 */


diff_match_patch.prototype.match_alphabet_ = function (pattern) {
  var s = {};

  for (var i = 0; i < pattern.length; i++) {
    s[pattern[i]] = 0;
  }

  for (var i = 0; i < pattern.length; i++) {
    s[pattern[i]] |= 1 << pattern.length - i - 1;
  }

  return s;
}; //  PATCH FUNCTIONS

/**
 * Increase the context until it is unique,
 * but don't let the pattern expand beyond Match_MaxBits.
 * @param {!diff_match_patch.patch_obj} patch The patch to grow.
 * @param {string} text Source text.
 * @private
 */


diff_match_patch.prototype.patch_addContext_ = function (patch, text) {
  if (text.length === 0) {
    return;
  }

  var pattern = text.slice(patch.start2, patch.start2 + patch.length1);
  var padding = 0; // Look for the first and last matches of pattern in text.  If two different
  // matches are found, increase the pattern length.

  while (text.indexOf(pattern) !== text.lastIndexOf(pattern) && pattern.length < this.Match_MaxBits - this.Patch_Margin - this.Patch_Margin) {
    padding += this.Patch_Margin;
    pattern = text.slice(Math.max(0, patch.start2 - padding), patch.start2 + patch.length1 + padding);
  } // Add one chunk for good luck.


  padding += this.Patch_Margin; // Add the prefix.

  var prefix = text.slice(Math.max(0, patch.start2 - padding), patch.start2);

  if (prefix) {
    patch.diffs.unshift([DIFF_EQUAL, prefix]);
  } // Add the suffix.


  var suffix = text.slice(patch.start2 + patch.length1, patch.start2 + patch.length1 + padding);

  if (suffix) {
    patch.diffs.push([DIFF_EQUAL, suffix]);
  } // Roll back the start points.


  patch.start1 -= prefix.length;
  patch.start2 -= prefix.length; // Extend the lengths.

  patch.length1 += prefix.length + suffix.length;
  patch.length2 += prefix.length + suffix.length;
};
/**
 * Compute a list of patches to turn text1 into text2.
 * Use diffs if provided, otherwise compute it ourselves.
 * There are four ways to call this function, depending on what data is
 * available to the caller:
 * Method 1:
 * a = text1, b = text2
 * Method 2:
 * a = diffs
 * Method 3 (optimal):
 * a = text1, b = diffs
 * Method 4 (deprecated, use method 3):
 * a = text1, b = text2, c = diffs
 *
 * @param {string|!Array.<!diff_match_patch.Diff>} a text1 (methods 1,3,4) or
 * Array of diff tuples for text1 to text2 (method 2).
 * @param {string|!Array.<!diff_match_patch.Diff>} opt_b text2 (methods 1,4) or
 * Array of diff tuples for text1 to text2 (method 3) or undefined (method 2).
 * @param {string|!Array.<!diff_match_patch.Diff>} opt_c Array of diff tuples
 * for text1 to text2 (method 4) or undefined (methods 1,2,3).
 * @return {!Array.<!diff_match_patch.patch_obj>} Array of Patch objects.
 */


diff_match_patch.prototype.patch_make = function (a, opt_b, opt_c) {
  var text1, diffs;

  if (typeof a === 'string' && typeof opt_b === 'string' && typeof opt_c === 'undefined') {
    // Method 1: text1, text2
    // Compute diffs from text1 and text2.
    text1 =
    /** @type {string} */
    a;
    diffs = this.diff_main(text1,
    /** @type {string} */
    opt_b, {
      checklines: true
    });

    if (diffs.length > 2) {
      this.diff_cleanupSemantic(diffs);
      this.diff_cleanupEfficiency(diffs);
    }
  } else if (a && _typeof(a) === 'object' && typeof opt_b === 'undefined' && typeof opt_c === 'undefined') {
    // Method 2: diffs
    // Compute text1 from diffs.
    diffs =
    /** @type {!Array.<!diff_match_patch.Diff>} */
    a;
    text1 = this.diff_text1(diffs);
  } else if (typeof a === 'string' && opt_b && _typeof(opt_b) === 'object' && typeof opt_c === 'undefined') {
    // Method 3: text1, diffs
    text1 =
    /** @type {string} */
    a;
    diffs =
    /** @type {!Array.<!diff_match_patch.Diff>} */
    opt_b;
  } else if (typeof a === 'string' && typeof opt_b === 'string' && opt_c && _typeof(opt_c) === 'object') {
    // Method 4: text1, text2, diffs
    // text2 is not used.
    text1 =
    /** @type {string} */
    a;
    diffs =
    /** @type {!Array.<!diff_match_patch.Diff>} */
    opt_c;
  } else {
    throw new Error('Unknown call format to patch_make.');
  }

  if (diffs.length === 0) {
    return []; // Get rid of the null case.
  }

  var patches = [];
  var patch = new diff_match_patch.patch_obj();
  var patchDiffLength = 0; // Keeping our own length var is faster in JS.

  var char_count1 = 0; // Number of characters into the text1 string.

  var char_count2 = 0; // Number of characters into the text2 string.
  // Start with text1 (prepatch_text) and apply the diffs until we arrive at
  // text2 (postpatch_text).  We recreate the patches one by one to determine
  // context info.

  var prepatch_text = text1;
  var postpatch_text = text1;

  for (var x = 0; x < diffs.length; x++) {
    var diff_type = diffs[x][0];
    var diff_text = diffs[x][1];

    if (!patchDiffLength && diff_type !== DIFF_EQUAL) {
      // A new patch starts here.
      patch.start1 = char_count1;
      patch.start2 = char_count2;
    }

    switch (diff_type) {
      case DIFF_INSERT:
        patch.diffs[patchDiffLength++] = diffs[x];
        patch.length2 += diff_text.length;
        postpatch_text = postpatch_text.slice(0, char_count2).concat(diff_text).concat(postpatch_text.slice(char_count2));
        break;

      case DIFF_DELETE:
        patch.length1 += diff_text.length;
        patch.diffs[patchDiffLength++] = diffs[x];
        postpatch_text = postpatch_text.slice(0, char_count2).concat(postpatch_text.slice(char_count2 + diff_text.length));
        break;

      case DIFF_EQUAL:
        if (diff_text.length <= 2 * this.Patch_Margin && patchDiffLength && diffs.length !== x + 1) {
          // Small equality inside a patch.
          patch.diffs[patchDiffLength++] = diffs[x];
          patch.length1 += diff_text.length;
          patch.length2 += diff_text.length;
        } else if (diff_text.length >= 2 * this.Patch_Margin) {
          // Time for a new patch.
          if (patchDiffLength) {
            this.patch_addContext_(patch, prepatch_text);
            patches.push(patch);
            patch = new diff_match_patch.patch_obj();
            patchDiffLength = 0; // Unlike Unidiff, our patch lists have a rolling context.
            // http://code.google.com/p/google-diff-match-patch/wiki/Unidiff
            // Update prepatch text & pos to reflect the application of the
            // just completed patch.

            prepatch_text = postpatch_text;
            char_count1 = char_count2;
          }
        }

        break;
    } // Update the current character count.


    if (diff_type !== DIFF_INSERT) {
      char_count1 += diff_text.length;
    }

    if (diff_type !== DIFF_DELETE) {
      char_count2 += diff_text.length;
    }
  } // Pick up the leftover patch if not empty.


  if (patchDiffLength) {
    this.patch_addContext_(patch, prepatch_text);
    patches.push(patch);
  }

  return patches;
};
/**
 * Given an array of patches, return another array that is identical.
 * @param {!Array.<!diff_match_patch.patch_obj>} patches Array of Patch objects.
 * @return {!Array.<!diff_match_patch.patch_obj>} Array of Patch objects.
 */


diff_match_patch.prototype.patch_deepCopy = function (patches) {
  // Making deep copies is hard in JavaScript.
  var patchesCopy = [];

  for (var x = 0; x < patches.length; x++) {
    var patch = patches[x];
    var patchCopy = new diff_match_patch.patch_obj();
    patchCopy.diffs = [];

    for (var y = 0; y < patch.diffs.length; y++) {
      patchCopy.diffs[y] = patch.diffs[y].slice();
    }

    patchCopy.start1 = patch.start1;
    patchCopy.start2 = patch.start2;
    patchCopy.length1 = patch.length1;
    patchCopy.length2 = patch.length2;
    patchesCopy[x] = patchCopy;
  }

  return patchesCopy;
};
/**
 * Merge a set of patches onto the text.  Return a patched text, as well
 * as a list of true/false values indicating which patches were applied.
 * @param {!Array.<!diff_match_patch.patch_obj>} patches Array of Patch objects.
 * @param {string} text Old text.
 * @return {!Array.<string|!Array.<boolean>>} Two element Array, containing the
 *      new text and an array of boolean values.
 */


diff_match_patch.prototype.patch_apply = function (patches, text) {
  if (patches.length === 0) {
    return [text, []];
  } // Deep copy the patches so that no changes are made to originals.


  patches = this.patch_deepCopy(patches);
  var nullPadding = this.patch_addPadding(patches);
  text = nullPadding.concat(text).concat(nullPadding);
  this.patch_splitMax(patches); // delta keeps track of the offset between the expected and actual location
  // of the previous patch.  If there are patches expected at positions 10 and
  // 20, but the first patch was found at 12, delta is 2 and the second patch
  // has an effective expected position of 22.

  var delta = 0;
  var results = [];

  for (var x = 0; x < patches.length; x++) {
    var expected_loc = patches[x].start2 + delta;
    var text1 = this.diff_text1(patches[x].diffs);
    var start_loc;
    var end_loc = -1;

    if (text1.length > this.Match_MaxBits) {
      // patch_splitMax will only provide an oversized pattern in the case of
      // a monster delete.
      start_loc = this.match_main(text, text1.slice(0, this.Match_MaxBits), expected_loc);

      if (start_loc !== -1) {
        end_loc = this.match_main(text, text1.slice(text1.length - this.Match_MaxBits), expected_loc + text1.length - this.Match_MaxBits);

        if (end_loc === -1 || start_loc >= end_loc) {
          // Can't find valid trailing context.  Drop this patch.
          start_loc = -1;
        }
      }
    } else {
      start_loc = this.match_main(text, text1, expected_loc);
    }

    if (start_loc === -1) {
      // No match found.  :(
      results[x] = false; // Subtract the delta for this failed patch from subsequent patches.

      delta -= patches[x].length2 - patches[x].length1;
    } else {
      // Found a match.  :)
      results[x] = true;
      delta = start_loc - expected_loc;
      var text2;

      if (end_loc === -1) {
        text2 = text.slice(start_loc, start_loc + text1.length);
      } else {
        text2 = text.slice(start_loc, end_loc + this.Match_MaxBits);
      }

      if (this.isEqualString(text1, text2)) {
        // Perfect match, just shove the replacement text in.
        text = text.slice(0, start_loc).concat(this.diff_text2(patches[x].diffs)).concat(text.slice(start_loc + text1.length));
      } else {
        // Imperfect match.  Run a diff to get a framework of equivalent
        // indices.
        var diffs = this.diff_main(text1, text2, {
          checklines: false
        });

        if (text1.length > this.Match_MaxBits && this.diff_levenshtein(diffs) / text1.length > this.Patch_DeleteThreshold) {
          // The end points match, but the content is unacceptably bad.
          results[x] = false;
        } else {
          this.diff_cleanupSemanticLossless(diffs);
          var index1 = 0;
          var index2;

          for (var y = 0; y < patches[x].diffs.length; y++) {
            var mod = patches[x].diffs[y];

            if (mod[0] !== DIFF_EQUAL) {
              index2 = this.diff_xIndex(diffs, index1);
            }

            if (mod[0] === DIFF_INSERT) {
              // Insertion
              text = text.slice(0, start_loc + index2).concat(mod[1]).concat(text.slice(start_loc + index2));
            } else if (mod[0] === DIFF_DELETE) {
              // Deletion
              text = text.slice(0, start_loc + index2).concat(text.slice(start_loc + this.diff_xIndex(diffs, index1 + mod[1].length)));
            }

            if (mod[0] !== DIFF_DELETE) {
              index1 += mod[1].length;
            }
          }
        }
      }
    }
  } // Strip the padding off.


  text = text.slice(nullPadding.length, text.length - nullPadding.length);
  return [text, results];
};
/**
 * Add some padding on text start and end so that edges can match something.
 * Intended to be called only from within patch_apply.
 * @param {!Array.<!diff_match_patch.patch_obj>} patches Array of Patch objects.
 * @return {string} The padding string added to each side.
 */


diff_match_patch.prototype.patch_addPadding = function (patches) {
  var paddingLength = this.Patch_Margin;
  var nullPadding = this.getEmptyString();

  for (var x = 1; x <= paddingLength; x++) {
    nullPadding = nullPadding.concat(String.fromCharCode(x));
  } // Bump all the patches forward.


  for (var x = 0; x < patches.length; x++) {
    patches[x].start1 += paddingLength;
    patches[x].start2 += paddingLength;
  } // Add some padding on start of first diff.


  var patch = patches[0];
  var diffs = patch.diffs;

  if (diffs.length === 0 || diffs[0][0] !== DIFF_EQUAL) {
    // Add nullPadding equality.
    diffs.unshift([DIFF_EQUAL, nullPadding]);
    patch.start1 -= paddingLength; // Should be 0.

    patch.start2 -= paddingLength; // Should be 0.

    patch.length1 += paddingLength;
    patch.length2 += paddingLength;
  } else if (paddingLength > diffs[0][1].length) {
    // Grow first equality.
    var extraLength = paddingLength - diffs[0][1].length;
    diffs[0][1] = nullPadding.slice(diffs[0][1].length).concat(diffs[0][1]);
    patch.start1 -= extraLength;
    patch.start2 -= extraLength;
    patch.length1 += extraLength;
    patch.length2 += extraLength;
  } // Add some padding on end of last diff.


  patch = patches[patches.length - 1];
  diffs = patch.diffs;

  if (diffs.length === 0 || diffs[diffs.length - 1][0] !== DIFF_EQUAL) {
    // Add nullPadding equality.
    diffs.push([DIFF_EQUAL, nullPadding]);
    patch.length1 += paddingLength;
    patch.length2 += paddingLength;
  } else if (paddingLength > diffs[diffs.length - 1][1].length) {
    // Grow last equality.
    var extraLength = paddingLength - diffs[diffs.length - 1][1].length;
    diffs[diffs.length - 1][1] = diffs[diffs.length - 1][1].concat(nullPadding.slice(0, extraLength));
    patch.length1 += extraLength;
    patch.length2 += extraLength;
  }

  return nullPadding;
};
/**
 * Look through the patches and break up any which are longer than the maximum
 * limit of the match algorithm.
 * Intended to be called only from within patch_apply.
 * @param {!Array.<!diff_match_patch.patch_obj>} patches Array of Patch objects.
 */


diff_match_patch.prototype.patch_splitMax = function (patches) {
  var patch_size = this.Match_MaxBits;

  for (var x = 0; x < patches.length; x++) {
    if (patches[x].length1 <= patch_size) {
      continue;
    }

    var bigpatch = patches[x]; // Remove the big old patch.

    patches.splice(x--, 1);
    var start1 = bigpatch.start1;
    var start2 = bigpatch.start2;
    var precontext = this.getEmptyString();

    while (bigpatch.diffs.length !== 0) {
      // Create one of several smaller patches.
      var patch = new diff_match_patch.patch_obj();
      var empty = true;
      patch.start1 = start1 - precontext.length;
      patch.start2 = start2 - precontext.length;

      if (precontext.length) {
        patch.length1 = patch.length2 = precontext.length;
        patch.diffs.push([DIFF_EQUAL, precontext]);
      }

      while (bigpatch.diffs.length !== 0 && patch.length1 < patch_size - this.Patch_Margin) {
        var diff_type = bigpatch.diffs[0][0];
        var diff_text = bigpatch.diffs[0][1];

        if (diff_type === DIFF_INSERT) {
          // Insertions are harmless.
          patch.length2 += diff_text.length;
          start2 += diff_text.length;
          patch.diffs.push(bigpatch.diffs.shift());
          empty = false;
        } else if (diff_type === DIFF_DELETE && patch.diffs.length === 1 && patch.diffs[0][0] === DIFF_EQUAL && diff_text.length > 2 * patch_size) {
          // This is a large deletion.  Let it pass in one chunk.
          patch.length1 += diff_text.length;
          start1 += diff_text.length;
          empty = false;
          patch.diffs.push([diff_type, diff_text]);
          bigpatch.diffs.shift();
        } else {
          // Deletion or equality.  Only take as much as we can stomach.
          diff_text = diff_text.slice(0, patch_size - patch.length1 - this.Patch_Margin);
          patch.length1 += diff_text.length;
          start1 += diff_text.length;

          if (diff_type === DIFF_EQUAL) {
            patch.length2 += diff_text.length;
            start2 += diff_text.length;
          } else {
            empty = false;
          }

          patch.diffs.push([diff_type, diff_text]);

          if (this.isEqualString(diff_text, bigpatch.diffs[0][1])) {
            bigpatch.diffs.shift();
          } else {
            bigpatch.diffs[0][1] = bigpatch.diffs[0][1].slice(diff_text.length);
          }
        }
      } // Compute the head context for the next patch.


      precontext = this.diff_text2(patch.diffs);
      precontext = precontext.slice(precontext.length - this.Patch_Margin); // Append the end context for this patch.

      var postcontext = this.diff_text1(bigpatch.diffs).slice(0, this.Patch_Margin);

      if (postcontext.length) {
        patch.length1 += postcontext.length;
        patch.length2 += postcontext.length;

        if (patch.diffs.length !== 0 && patch.diffs[patch.diffs.length - 1][0] === DIFF_EQUAL) {
          patch.diffs[patch.diffs.length - 1][1] = patch.diffs[patch.diffs.length - 1][1].concat(postcontext);
        } else {
          patch.diffs.push([DIFF_EQUAL, postcontext]);
        }
      }

      if (!empty) {
        patches.splice(++x, 0, patch);
      }
    }
  }
};
/**
 * Take a list of patches and return a textual representation.
 * @param {!Array.<!diff_match_patch.patch_obj>} patches Array of Patch objects.
 * @return {string} Text representation of patches.
 */


diff_match_patch.prototype.patch_toText = function (patches) {
  var text = [];

  for (var x = 0; x < patches.length; x++) {
    text[x] = patches[x];
  }

  return this.charsToString(text);
};
/**
 * Parse a textual representation of patches and return a list of Patch objects.
 * @param {string} textline Text representation of patches.
 * @return {!Array.<!diff_match_patch.patch_obj>} Array of Patch objects.
 * @throws {!Error} If invalid input.
 */


diff_match_patch.prototype.patch_fromText = function (textline) {
  var patches = [];

  if (!textline) {
    return patches;
  }

  var text = textline.split('\n');
  var textPointer = 0;
  var patchHeader = /^@@ -(\d+),?(\d*) \+(\d+),?(\d*) @@$/;

  while (textPointer < text.length) {
    var m = text[textPointer].match(patchHeader);

    if (!m) {
      throw new Error('Invalid patch string: ' + text[textPointer]);
    }

    var patch = new diff_match_patch.patch_obj();
    patches.push(patch);
    patch.start1 = parseInt(m[1], 10);

    if (m[2] === '') {
      patch.start1--;
      patch.length1 = 1;
    } else if (m[2] === '0') {
      patch.length1 = 0;
    } else {
      patch.start1--;
      patch.length1 = parseInt(m[2], 10);
    }

    patch.start2 = parseInt(m[3], 10);

    if (m[4] === '') {
      patch.start2--;
      patch.length2 = 1;
    } else if (m[4] === '0') {
      patch.length2 = 0;
    } else {
      patch.start2--;
      patch.length2 = parseInt(m[4], 10);
    }

    textPointer++;

    while (textPointer < text.length) {
      var sign = text[textPointer][0];

      try {
        var line = decodeURI(text[textPointer].slice(1));
      } catch (ex) {
        // Malformed URI sequence.
        throw new Error('Illegal escape in patch_fromText: ' + line);
      }

      if (sign === '-') {
        // Deletion.
        patch.diffs.push([DIFF_DELETE, line]);
      } else if (sign === '+') {
        // Insertion.
        patch.diffs.push([DIFF_INSERT, line]);
      } else if (sign === ' ') {
        // Minor equality.
        patch.diffs.push([DIFF_EQUAL, line]);
      } else if (sign === '@') {
        // Start of next patch.
        break;
      } else if (sign === undefined) ; else {
        // WTF?
        throw new Error('Invalid patch mode "' + sign + '" in: ' + line);
      }

      textPointer++;
    }
  }

  return patches;
};
/**
 * Class representing one patch operation.
 * @constructor
 */


diff_match_patch.patch_obj = function () {
  /** @type {!Array.<!diff_match_patch.Diff>} */
  this.diffs = [];
  /** @type {?number} */

  this.start1 = null;
  /** @type {?number} */

  this.start2 = null;
  /** @type {number} */

  this.length1 = 0;
  /** @type {number} */

  this.length2 = 0;
};
/**
 * Emmulate GNU diff's format.
 * Header: @@ -382,8 +481,9 @@
 * Indicies are printed as 1-based, not 0-based.
 * @return {string} The GNU diff string.
 */


diff_match_patch.patch_obj.prototype.toString = function () {
  var coords1, coords2;

  if (this.length1 === 0) {
    coords1 = this.start1 + ',0';
  } else if (this.length1 === 1) {
    coords1 = this.start1 + 1;
  } else {
    coords1 = this.start1 + 1 + ',' + this.length1;
  }

  if (this.length2 === 0) {
    coords2 = this.start2 + ',0';
  } else if (this.length2 === 1) {
    coords2 = this.start2 + 1;
  } else {
    coords2 = this.start2 + 1 + ',' + this.length2;
  }

  var text = ['@@ -' + coords1 + ' +' + coords2 + ' @@\n'];
  var op; // Escape the body of the patch with %xx notation.

  for (var x = 0; x < this.diffs.length; x++) {
    switch (this.diffs[x][0]) {
      case DIFF_INSERT:
        op = '+';
        break;

      case DIFF_DELETE:
        op = '-';
        break;

      case DIFF_EQUAL:
        op = ' ';
        break;
    }

    text[x + 1] = op + encodeURI(this.diffs[x][1]) + '\n';
  }

  return text.join('').replace(/%20/g, ' ');
}; // Export these global variables so that they survive Google's JS compiler.

var LinearDiffer = /*#__PURE__*/function (_DiffMatchPatch) {
  _inherits(LinearDiffer, _DiffMatchPatch);

  var _super = _createSuper(LinearDiffer);

  function LinearDiffer() {
    _classCallCheck(this, LinearDiffer);

    return _super.apply(this, arguments);
  }

  _createClass(LinearDiffer, [{
    key: "indexOf",
    value: function indexOf(haystack, needle) {
      var needleLength = needle.length;
      var hayStackLength = haystack.length;

      if (needleLength === 0) {
        return needleLength;
      }

      if (hayStackLength < needleLength) {
        return -1;
      }

      var charTable = this._makeCharTable(needle);

      var offsetTable = this._makeOffsetTable(needle);

      for (var i = needleLength - 1; i < hayStackLength;) {
        var k = void 0;

        for (k = needleLength - 1; this.isEqualChar(needle[k], haystack[i]); i--, k--) {
          if (k === 0) {
            return i;
          }
        }

        i += Math.max(offsetTable[needleLength - 1 - k], charTable[JSON.stringify(haystack[i])]);
      }

      return -1;
    }
  }, {
    key: "_makeCharTable",
    value: function _makeCharTable(needle) {
      var table = {};
      needle.forEach(function (_char, index) {
        table[JSON.stringify(_char)] = index === needle.length - 1 ? needle.length : needle.length - index - 1;
      });
      return table;
    }
  }, {
    key: "_makeOffsetTable",
    value: function _makeOffsetTable(needle) {
      var suffix;
      var lastIndex = needle.length - 1;
      var lastPrefix = needle.length;
      var table = new Uint32Array(needle.length);

      for (var i = lastIndex; i >= 0; i--) {
        if (this._isPrefix(needle, i + 1)) {
          lastPrefix = i + 1;
        }

        table[lastIndex - i] = lastPrefix - i + lastIndex;
      }

      for (var _i = 0; _i < needle.length; _i++) {
        suffix = this._suffixLength(needle, _i);
        table[suffix] = lastIndex - _i + suffix;
      }

      return table;
    }
  }, {
    key: "_isPrefix",
    value: function _isPrefix(needle, i) {
      for (var k = 0; i < needle.length; i++, k++) {
        if (!this.isEqualChar(needle[i], needle[k])) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "_suffixLength",
    value: function _suffixLength(needle, i) {
      var length = 0;

      for (var checkPos = needle.length - 1; i >= 0 && needle[i] === needle[checkPos]; i--, checkPos--) {
        length += 1;
      }

      return length;
    }
  }, {
    key: "isEqualChar",
    value: function isEqualChar(a, b) {
      if (a === b) {
        return true;
      }

      if (a === undefined || b === undefined) {
        return false;
      }

      if (a.text !== b.text) {
        return false;
      }

      return JSON.stringify(a.decorations) === JSON.stringify(b.decorations);
    }
  }, {
    key: "isEqualString",
    value: function isEqualString(a, b) {
      if (a === b) {
        return true;
      }

      if (a === null || b === null) {
        return false;
      }

      if (a.length !== b.length) {
        return false;
      }

      for (var i = 0, l = a.length; i < l; i++) {
        if (!this.isEqualChar(a[i], b[i])) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "charsToString",
    value: function charsToString(chars) {
      return chars.slice();
    }
  }, {
    key: "getEmptyString",
    value: function getEmptyString() {
      return [];
    }
  }, {
    key: "matchChar",
    value: function matchChar(_char2, regex) {
      return _char2.text.match(regex);
    }
  }, {
    key: "matchString",
    value: function matchString(string, regex) {
      return string.map(function (c) {
        return c.text;
      }).join('').match(regex);
    }
  }, {
    key: "diff",
    value: function diff(oldData, newData) {
      // Remove empty edits
      var diff = this.diff_main(oldData, newData, {
        checklines: false
      });
      this.diff_cleanupSemantic(diff);
      var cleanedDiff = []; // Merge consecutive insertions and deletions

      var lastType, lastContent;
      diff.filter(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            _ = _ref2[0],
            content = _ref2[1];

        return content.length > 0;
      }).forEach(function (_ref3) {
        var _lastContent;

        var _ref4 = _slicedToArray(_ref3, 2),
            type = _ref4[0],
            content = _ref4[1];

        if (lastType === undefined || lastType !== type) {
          lastType = type;
          lastContent = content;
          cleanedDiff.push([lastType, lastContent]);
          return;
        }

        (_lastContent = lastContent).push.apply(_lastContent, _toConsumableArray(content));
      });
      return cleanedDiff;
    }
  }]);

  return LinearDiffer;
}(diff_match_patch);

var decorationsMatch = function decorationsMatch(a, b) {
  return a === b || JSON.stringify(a) === JSON.stringify(b);
};

var decorationsStartWith = function decorationsStartWith(reference, prefix) {
  return prefix.length > reference ? false : prefix.reduce(function (acc, current, i) {
    return acc && decorationsMatch(reference[i], current);
  }, true);
};

var LinearDiff = {
  name: 'LinearDiff',
  props: {
    tag: {
      type: String,
      "default": function _default() {
        return 'p';
      }
    },
    old: {
      type: String,
      required: true
    },
    "new": {
      type: String,
      required: true
    }
  },
  data: function data() {
    var differ = new LinearDiffer();
    differ.Diff_Timeout = 0;
    return {
      diff: null,
      differ: differ
    };
  },
  watch: {
    tag: function tag() {
      this.updateDiff();
    },
    old: function old() {
      this.updateDiff();
    },
    "new": function _new() {
      this.updateDiff();
    }
  },
  mounted: function mounted() {
    this.updateDiff();
  },
  render: function render(h) {
    var _this = this;

    if (this.diff === null) {
      return h(this.tag, {
        "class": ['vuesual-diff', 'vuesual-diff--linear', 'vuesual-diff--placeholder']
      }, [this.$slots.placeholder || 'Computing diff...']);
    }

    function renderNode(node) {
      if (node.children === undefined) {
        return node.text;
      }

      return h(node.tag, {
        attrs: node.attrs
      }, node.children.map(renderNode));
    }

    var children = this.diff.flatMap(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          type = _ref2[0],
          content = _ref2[1];

      var renderedContent = _this.rebuildTree(content).map(renderNode);

      if (type === DIFF_EQUAL) {
        return renderedContent;
      }

      if (type === DIFF_INSERT) {
        return [h('ins', {
          "class": 'vuesual-diff__inserted'
        }, renderedContent)];
      }

      return [h('del', {
        "class": 'vuesual-diff__deleted'
      }, renderedContent)];
    });
    return h(this.tag, {
      "class": ['vuesual-diff', 'vuesual-diff--linear']
    }, children);
  },
  methods: {
    updateDiff: function updateDiff() {
      var _this2 = this;

      return _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
        var oldElement, newElement, linearizedOld, linearizedNew;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                oldElement = document.createElement(_this2.tag);
                oldElement.innerHTML = _this2.old;
                newElement = document.createElement(_this2.tag);
                newElement.innerHTML = _this2["new"];
                linearizedOld = _this2.linearizeContent(oldElement);
                linearizedNew = _this2.linearizeContent(newElement);
                _this2.diff = _this2.differ.diff(linearizedOld, linearizedNew);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    linearizeContent: function linearizeContent(root) {
      function linearize(node, decorations) {
        if (node.nodeType === Node.COMMENT_NODE) {
          return [];
        }

        if (node.nodeType === Node.TEXT_NODE) {
          return Array.from(node.textContent).map(function (_char) {
            return {
              text: _char,
              decorations: decorations
            };
          });
        }

        var content = [];
        node.childNodes.forEach(function (child) {
          var attrs = {};
          var attributes = node.attributes;

          if (attributes !== undefined) {
            for (var i = 0; i < attributes.length; i++) {
              attrs[attributes[i].name] = attributes[i].value;
            }
          }

          content.push.apply(content, _toConsumableArray(linearize(child, [].concat(_toConsumableArray(decorations), [{
            tag: node.nodeName,
            attrs: attrs
          }]))));
        });
        return content;
      }

      var linearized = [];
      root.childNodes.forEach(function (child) {
        linearized.push.apply(linearized, _toConsumableArray(linearize(child, [])));
      });
      return linearized;
    },
    rebuildTree: function rebuildTree(linearized) {
      var rootNode = {
        children: []
      };
      var currentNode;
      var prefix = [];
      var nodeStack = [rootNode];
      linearized.forEach(function (_ref3) {
        var text = _ref3.text,
            decorations = _ref3.decorations;

        if (currentNode === undefined) {
          var _lastNode = rootNode;
          decorations.forEach(function (deco) {
            var node = {
              tag: deco.tag,
              attrs: deco.attrs,
              children: []
            };

            _lastNode.children.push(node);

            _lastNode = node;
            nodeStack.push(_lastNode);
          });
          currentNode = {
            text: text
          };

          _lastNode.children.push(currentNode);

          prefix = _toConsumableArray(decorations);
          return;
        }

        if (decorationsMatch(prefix, decorations)) {
          currentNode.text += text;
          return;
        }

        var lastNode = nodeStack.pop();

        while (!decorationsStartWith(decorations, prefix)) {
          prefix.pop();
          lastNode = nodeStack.pop();
        }

        nodeStack.push(lastNode);
        decorations.slice(prefix.length).forEach(function (deco) {
          var node = {
            tag: deco.tag,
            attrs: deco.attrs,
            children: []
          };
          lastNode.children.push(node);
          lastNode = node;
          nodeStack.push(lastNode);
        });
        currentNode = {
          text: text
        };
        lastNode.children.push(currentNode);
        prefix = _toConsumableArray(decorations);
      });
      return rootNode.children;
    }
  }
};

// Copyright (c) 2016 Thalia Chan under the terms of The MIT License (MIT)
// https://github.com/Tchanders/treeDiffer

/* eslint-disable */

/**
 * TreeNode
 *
 * Abstract TreeNode class for Trees to be diffed. It should be extended,
 * then a Tree should be built by passing the root node and the name of
 * the new class into the Tree constructor.
 *
 * @class
 * @constructor
 * @param {Object} node Object representing a node to be wrapped
 */
var TreeNode = function TreeNode(node) {
  /**
   * @property {Object} node Object representing the wrapped node
   */
  this.node = node;
  /**
   * @property {TreeNode[]} children Child nodes
   */

  this.children = [];
  /**
   * @property {number} index Index in node list ordered by deepest-first then document order
   */

  this.index = null;
  /**
   * @property {number} leftmost Leftmost of this node; see treeDiffer.Tree
   */

  this.leftmost = null;
};
/**
 * Add a node to the list of this node's children
 *
 * @param {TreeNode} child
 */


TreeNode.prototype.addChild = function (child) {
  this.children.push(child);
  child.parent = this;
};
/**
 * @method
 * Check if another TreeNode is equal to this node. Conditions for equality
 * will depend on the use case.
 *
 * @param {TreeNode} other The other TreeNode
 * @return {boolean} True if equal
 */


TreeNode.prototype.isEqual = null;
/**
 * @method
 *
 * Get the children of the node that this tree node wraps. How to
 * find and filter children will depend on the use case.
 *
 * @return {Object[]} Children of the wrapped node
 */

TreeNode.prototype.getOriginalNodeChildren = null;

// Copyright (c) 2016 Thalia Chan under the terms of The MIT License (MIT)

/* eslint-disable */

/**
 * Tree
 *
 * A group of TreeNodes connected by parent-child relationships in a tree
 * structure, along with certain properties that define the exact structure of the
 * tree: the node order, the keyroots, and the leftmost node of each node. (Terms
 * defined in: http://epubs.siam.org/doi/abs/10.1137/0218082?journalCode=smjcat)
 *
 * @class
 * @constructor
 *
 * @param {TreeNode} node Root node of the tree
 * @param {Function} nodeClass Concrete subclass of TreeNode
 * @param {Object} config Config options for nodeClass
 */
var Tree = function Tree(node, nodeClass, config) {
  this.root = null;
  this.nodeClass = nodeClass;
  this.orderedNodes = [];
  this.keyRoots = [];
  this.findKeyRootsAndOrderedNodes(node, config);
};
/**
 * Find the post-ordering of the tree nodes, the keyroots and the leftmost of each
 * node.
 *
 * @param {Object} node Root node in original tree
 * @param {Object} config Config options for nodeClass
 */


Tree.prototype.findKeyRootsAndOrderedNodes = function (node, config) {
  var leftmost,
      leftmostsToKeyRoots = {},
      tree = this;
  /**
   * Find the tree nodes in post-order, find the leftmost of each node, and store
   * the order and leftmost as properties of the nodes.
   *
   * @param {TreeNode} treeNode Node currently being checked
   * @param {Array} orderedNodes Array to be populated with nodes in order
   * @param {Object} leftmostsToKeyRoots Each keyroot and its leftmost
   */

  function postOrderNodes(treeNode, orderedNodes, leftmostsToKeyRoots) {
    var i,
        ilen,
        childNode,
        children = treeNode.getOriginalNodeChildren();

    for (i = 0, ilen = children.length; i < ilen; i++) {
      // eslint-disable-next-line new-cap
      childNode = new tree.nodeClass(children[i], config);
      treeNode.addChild(childNode);
      postOrderNodes(childNode, orderedNodes, leftmostsToKeyRoots);
    } // Record node order


    orderedNodes.push(treeNode);
    treeNode.index = orderedNodes.length - 1; // Record index of leftmost node
    // If this node is a leaf, it is its own leftmost

    treeNode.leftmost = treeNode.children.length === 0 ? treeNode.index : treeNode.children[0].leftmost; // Update the key root corresponding to this leftmost
    // A keyroot is the higest indexed node with each leftmost

    leftmostsToKeyRoots[treeNode.leftmost] = treeNode.index;
  } // Store the nodes in order
  // eslint-disable-next-line new-cap


  this.root = new tree.nodeClass(node, config);
  this.orderedNodes = [];
  postOrderNodes(this.root, this.orderedNodes, leftmostsToKeyRoots); // Store the the key roots in order of node index

  for (leftmost in leftmostsToKeyRoots) {
    this.keyRoots.push(leftmostsToKeyRoots[leftmost]);
  }

  this.keyRoots.sort(function (a, b) {
    return a - b;
  });
};
/**
 * Get all the descendants of a node
 *
 * @param {TreeNode} node Node whose descendants to find
 * @return {Array} Descendants of the node
 */


Tree.prototype.getNodeDescendants = function (node) {
  var descendants = [];

  function addDescendants(parentNode) {
    var i, ilen, childNode;

    for (i = 0, ilen = parentNode.children.length; i < ilen; i++) {
      childNode = parentNode.children[i];
      descendants.push(childNode);
      addDescendants(childNode);
    }
  }

  addDescendants(node);
  return descendants;
};

// Copyright (c) 2016 Thalia Chan under the terms of The MIT License (MIT)

/* eslint-disable */
// eslint-disable dot-notation
// We use [ 'null' ] as an index, but for consistencty with
// variable indicies [ i ][ j ] we prefer not to use dot notation

/**
 * Differ
 *
 * Find the minimum transactions to get from the first tree to the second tree. Each
 * transaction is of the form [nodeToRemove, nodeToInsert], where nodeToRemove or
 * nodeToInsert (but not both) can be null. The tree diffing algorithm is presented in:
 * http://epubs.siam.org/doi/abs/10.1137/0218082?journalCode=smjcat
 *
 * @class
 * @constructor
 * @param {Tree} tree1 First tree
 * @param {Tree} tree2 Second tree
 * @param {Number} [timeout=1000] Timeout after which to stop diffing
 */
var Differ = function Differ(tree1, tree2, timeout) {
  var i,
      ilen,
      j,
      jlen,
      transactions,
      transactionIndex = 0;
  this.endTime = new Date().getTime() + (timeout || 1000);
  this.tree1 = tree1;
  this.tree2 = tree2;
  this.insertCost = 1;
  this.removeCost = 1;
  this.changeCost = 1; // Temporary, changing store of transactions

  transactions = {
    'null': {
      'null': []
    }
  }; // Permanent store of transactions such that transactions[x][y] is the minimum
  // transactions to get from the sub-tree rooted at node x (in tree1) to the sub-tree
  // rooted at node y (in tree2).

  this.transactions = {
    'null': {}
  }; // All possible transactions

  this.indexToTransaction = [];
  this.indexToTransaction.push([null, null]); // Indices for each transaction, to avoid high performance cost of creating the
  // transactions multiple times

  this.transactionToIndex = {
    'null': {
      'null': 0
    }
  };
  transactionIndex += 1; // Populate transaction stores

  for (i = 0, ilen = this.tree1.orderedNodes.length; i < ilen; i++) {
    transactions[i] = {
      'null': []
    };
    this.transactionToIndex[i] = {
      'null': transactionIndex
    };
    transactionIndex += 1;
    this.indexToTransaction.push([i, null]);

    for (j = 0, jlen = this.tree2.orderedNodes.length; j < jlen; j++) {
      transactions[null][j] = [];
      transactions[i][j] = [];
      this.transactionToIndex[null][j] = transactionIndex;
      transactionIndex += 1;
      this.indexToTransaction.push([null, j]);
      this.transactionToIndex[i][j] = transactionIndex;
      transactionIndex += 1;
      this.indexToTransaction.push([i, j]);
    }

    this.transactions[i] = {};
  }

  this.populateTransactions(transactions);
};
/**
 * Populate this.transactions with minimum transactions between all possible trees
 *
 * @param {Object} transactions Temporary store of transactions between trees
 */


Differ.prototype.populateTransactions = function (transactions) {
  var i,
      ilen,
      j,
      jlen,
      iNulls,
      jNulls,
      ii,
      jj,
      keyRoot1,
      keyRoot2,
      differ = this;

  function getTransactionFromIndex(index) {
    return differ.indexToTransaction[index];
  }

  for (i = 0, ilen = this.tree1.keyRoots.length; i < ilen; i++) {
    // Make transactions for tree -> null
    keyRoot1 = this.tree1.orderedNodes[this.tree1.keyRoots[i]];
    iNulls = [];

    for (ii = keyRoot1.leftmost; ii < keyRoot1.index + 1; ii++) {
      iNulls.push(this.transactionToIndex[ii][null]);
      transactions[ii][null] = iNulls.slice();
    }

    for (j = 0, jlen = this.tree2.keyRoots.length; j < jlen; j++) {
      // Make transactions of null -> tree
      keyRoot2 = this.tree2.orderedNodes[this.tree2.keyRoots[j]];
      jNulls = [];

      for (jj = keyRoot2.leftmost; jj < keyRoot2.index + 1; jj++) {
        jNulls.push(this.transactionToIndex[null][jj]);
        transactions[null][jj] = jNulls.slice();
      } // Get the diff


      this.findMinimumTransactions(keyRoot1, keyRoot2, iNulls, jNulls, transactions);

      if (new Date().getTime() > this.endTime) {
        this.transactions = null;
        return;
      }
    }
  }

  for (i = 0, ilen = this.tree1.orderedNodes.length; i < ilen; i++) {
    for (j = 0, jlen = this.tree2.orderedNodes.length; j < jlen; j++) {
      if (this.transactions[i][j] && this.transactions[i][j].length > 0) {
        this.transactions[i][j] = this.transactions[i][j].map(getTransactionFromIndex);
      }
    }
  }
};
/**
 * Get the cost of removing a node from the first tree, inserting a node into the second
 * tree, or relabelling a node from the first tree to a node from the second tree.
 *
 * @param {TreeNode} node1 Node from the first tree
 * @param {TreeNode} node2 Node from the second tree]
 * @return {number} Cost of the transaction
 */


Differ.prototype.getNodeDistance = function (node1, node2) {
  if (node1 === null && node2 === null) {
    return 0;
  }

  if (node1 === null) {
    return this.insertCost;
  }

  if (node2 === null) {
    return this.removeCost;
  }

  if (node1.isEqual(node2)) {
    return 0;
  }

  return this.changeCost;
};
/**
 * Find the minimum transactions to get from the first tree to the second tree. This
 * method is the heart of the tree differ.
 *
 * @param {TreeNode} keyRoot1 A keyroot from the first tree
 * @param {TreeNode} keyRoot2 A keyroot from the second tree
 * @param {Object} iNulls Transactions from all relevant sub-trees to the null tree
 * @param {Object} jNulls Transactions from the null tree to all relevant sub-trees
 * @param {Object} transactions Temporary store of transactions between trees
 */


Differ.prototype.findMinimumTransactions = function (keyRoot1, keyRoot2, iNulls, jNulls, transactions) {
  var i, j, iMinus1, jMinus1, costs, nodeDistance, transaction, remove, insert, change;

  for (i = keyRoot1.leftmost; i < keyRoot1.index + 1; i++) {
    iMinus1 = i === keyRoot1.leftmost ? null : i - 1;

    for (j = keyRoot2.leftmost; j < keyRoot2.index + 1; j++) {
      jMinus1 = j === keyRoot2.leftmost ? null : j - 1;

      if (this.tree1.orderedNodes[i].leftmost === keyRoot1.leftmost && this.tree2.orderedNodes[j].leftmost === keyRoot2.leftmost) {
        // Previous transactions, leading up to a remove, insert or change
        remove = transactions[iMinus1][j];
        insert = transactions[i][jMinus1];
        change = transactions[iMinus1][jMinus1];
        nodeDistance = this.getNodeDistance(this.tree1.orderedNodes[i], this.tree2.orderedNodes[j]); // Cost of each transaction

        costs = [remove.length + this.removeCost, insert.length + this.insertCost, change.length + nodeDistance];
        transaction = costs.indexOf(Math.min.apply(null, costs));

        if (transaction === 0) {
          // Record a remove
          (transactions[i][j] = remove.slice()).push(this.transactionToIndex[i][null]);
        } else if (transaction === 1) {
          // Record an insert
          (transactions[i][j] = insert.slice()).push(this.transactionToIndex[null][j]);
        } else {
          transactions[i][j] = change.slice(); // If nodes i and j are different, record a change,
          // otherwise there is no transaction

          if (nodeDistance === 1) {
            transactions[i][j].push(this.transactionToIndex[i][j]);
          }
        }

        this.transactions[i][j] = transactions[i][j].slice();
      } else {
        // Previous transactions, leading up to a remove, insert or change
        remove = transactions[iMinus1][j];
        insert = transactions[i][jMinus1];
        change = transactions[this.tree1.orderedNodes[i].leftmost - 1 < keyRoot1.leftmost ? null : this.tree1.orderedNodes[i].leftmost - 1][this.tree2.orderedNodes[j].leftmost - 1 < keyRoot2.leftmost ? null : this.tree2.orderedNodes[j].leftmost - 1];
        costs = [remove.length + this.removeCost, insert.length + this.insertCost, change.length + this.transactions[i][j].length];
        transaction = costs.indexOf(Math.min.apply(null, costs));

        if (transaction === 0) {
          // Record a remove
          (transactions[i][j] = remove.slice()).push(this.transactionToIndex[i][null]);
        } else if (transaction === 1) {
          // Record an insert
          (transactions[i][j] = insert.slice()).push(this.transactionToIndex[null][j]);
        } else {
          // Record a change
          transactions[i][j] = change.concat(this.transactions[i][j]);
        }
      }
    }
  }
};
/**
 * Given a set of transactions and the lengths of two trees, find the nodes that
 * correspond.
 *
 * @param {Array} transactions Minimum transactions to get from the first tree to the
 * second tree
 * @param {number} oldTreeLength Number of nodes in the first tree
 * @param {number} newTreeLength Number of nodes in the second tree
 * @return {Object} Corresponding nodes
 */


Differ.prototype.getCorrespondingNodes = function (transactions, oldTreeLength, newTreeLength) {
  var i,
      j,
      rem,
      ins,
      oldToNew = {},
      newToOld = {},
      remove = [],
      insert = [],
      change = {},
      ilen = Math.max(oldTreeLength, newTreeLength),
      jlen = ilen;

  for (i = 0; i < transactions.length; i++) {
    if (transactions[i][0] === null) {
      insert.push(transactions[i][1]);
    } else if (transactions[i][1] === null) {
      remove.push(transactions[i][0]);
    } else {
      oldToNew[transactions[i][0]] = transactions[i][1];
      newToOld[transactions[i][1]] = transactions[i][0];
      change[transactions[i][0]] = transactions[i][1];
    }
  }

  rem = remove.slice();
  ins = insert.slice();
  remove.sort(function (a, b) {
    return a - b;
  });
  insert.sort(function (a, b) {
    return a - b;
  });

  for (i = 0, j = 0; i < ilen && j < jlen; i++, j++) {
    if (i === remove[0]) {
      // Old node is a remove
      remove.shift();
      j--;
    } else if (j === insert[0]) {
      // New node is an insert
      insert.shift();
      i--;
    } else if (!(i in oldToNew) && !(j in newToOld)) {
      // Neither is changed, so they must correspond
      // NB Moves don't exist to the tree differ
      oldToNew[i] = j;
      newToOld[j] = i;
    } else if (!(i in oldToNew)) {
      // Old node is unchanged, new node is changed
      i--;
    } else if (!(j in newToOld)) {
      // New node is unchanged, old node is changed
      j--;
    }
  }

  return {
    oldToNew: oldToNew,
    newToOld: newToOld,
    remove: rem,
    insert: ins,
    change: change
  };
};

var DomTreeNode = /*#__PURE__*/function (_TreeNode) {
  _inherits(DomTreeNode, _TreeNode);

  var _super = _createSuper(DomTreeNode);

  function DomTreeNode() {
    _classCallCheck(this, DomTreeNode);

    return _super.apply(this, arguments);
  }

  _createClass(DomTreeNode, [{
    key: "isEqual",
    value: function isEqual(otherNode) {
      if (this.node.inline) {
        return otherNode.node.inline && otherNode.node.tag === this.node.tag && otherNode.node.content === this.node.content && JSON.stringify(otherNode.node.attrs) === JSON.stringify(this.node.attrs);
      }

      return otherNode.node.tag === this.node.tag && JSON.stringify(otherNode.node.attrs) === JSON.stringify(this.node.attrs);
    }
  }, {
    key: "getOriginalNodeChildren",
    value: function getOriginalNodeChildren() {
      if (this.node.inline) {
        return [];
      }

      return _toConsumableArray(this.node.children);
    }
  }]);

  return DomTreeNode;
}(TreeNode);

var TreeDiff = {
  name: 'TreeDiff',
  components: {
    LinearDiff: LinearDiff
  },
  props: {
    tag: {
      type: String,
      "default": function _default() {
        return 'div';
      }
    },
    old: {
      type: String,
      required: true
    },
    "new": {
      type: String,
      required: true
    },
    blockTags: {
      type: Array,
      "default": function _default() {
        return ['div', 'table', 'ul', 'ol'];
      }
    }
  },
  data: function data() {
    return {
      diff: null
    };
  },
  watch: {
    tag: function tag() {
      this.updateDiff();
    },
    old: function old() {
      this.updateDiff();
    },
    "new": function _new() {
      this.updateDiff();
    },
    blockTags: function blockTags() {
      this.updateDiff();
    }
  },
  mounted: function mounted() {
    this.updateDiff();
  },
  render: function render(h) {
    var _this = this;

    if (this.diff === null) {
      return h(this.tag, {
        "class": ['vuesual-diff', 'vuesual-diff--tree', 'vuesual-diff--placeholder']
      }, [this.$slots.placeholder || 'Computing diff...']);
    }

    var renderNode = function renderNode(node, classList) {
      if (node.hide) {
        return [];
      }

      if (node.inline) {
        var tag = node.tag === '#text' ? 'span' : node.tag;

        if (node.changed && node.oldContent) {
          return [h(LinearDiff, {
            "class": [].concat(_toConsumableArray(classList), ['vuesual-diff__sub-diff']),
            attrs: node.attrs,
            props: {
              tag: tag,
              old: node.oldContent,
              "new": node.content
            }
          }, [_this.$slots.linearPlaceholder ? h('template', {
            slot: 'placeholder'
          }, [_this.$slots.linearPlaceholder]) : undefined].filter(function (child) {
            return child !== undefined;
          }))];
        } else if (node.changed && node.replaces) {
          return [].concat(_toConsumableArray(renderNode(node.replaces, [].concat(_toConsumableArray(classList), ['vuesual-diff__deleted']))), [h(tag, {
            "class": [].concat(_toConsumableArray(classList), ['vuesual-diff__inserted']),
            attrs: node.attrs,
            domProps: {
              innerHTML: node.content
            }
          })]);
        }

        return [h(tag, {
          "class": [].concat(_toConsumableArray(classList), _toConsumableArray(node.inserted ? ['vuesual-diff__inserted'] : []), _toConsumableArray(node.deleted ? ['vuesual-diff__deleted'] : [])),
          attrs: node.attrs,
          domProps: {
            innerHTML: node.content
          }
        })];
      }

      var renderedChilds = node.children.flatMap(function (child) {
        return renderNode(child, []);
      });

      if (node.changed && node.replaces) {
        return [].concat(_toConsumableArray(renderNode(node.replaces, [].concat(_toConsumableArray(classList), ['vuesual-diff__deleted']))), [h(node.tag, {
          "class": [].concat(_toConsumableArray(classList), ['vuesual-diff__inserted']),
          attrs: node.attrs
        }, renderedChilds)]);
      }

      return [h(node.tag, {
        "class": [].concat(_toConsumableArray(classList), _toConsumableArray(node.inserted ? ['vuesual-diff__inserted'] : []), _toConsumableArray(node.deleted ? ['vuesual-diff__deleted'] : [])),
        attrs: node.attrs
      }, renderedChilds)];
    };

    return h(this.tag, {
      "class": ['vuesual-diff', 'vuesual-diff--tree']
    }, this.diff.children.flatMap(function (child) {
      return renderNode(child, []);
    }));
  },
  methods: {
    updateDiff: function updateDiff() {
      var _this2 = this;

      return _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
        var oldElement, newElement, oldTree, newTree, differ, transactions, correspondingNodes;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                oldElement = document.createElement(_this2.tag);
                oldElement.innerHTML = _this2.old;
                newElement = document.createElement(_this2.tag);
                newElement.innerHTML = _this2["new"];
                oldTree = new Tree(_this2.buildTree(oldElement), DomTreeNode);
                newTree = new Tree(_this2.buildTree(newElement), DomTreeNode);
                differ = new Differ(oldTree, newTree);
                transactions = differ.transactions[oldTree.orderedNodes.length - 1][newTree.orderedNodes.length - 1];
                correspondingNodes = Differ.prototype.getCorrespondingNodes(transactions, oldTree.orderedNodes.length, newTree.orderedNodes.length);
                transactions.reverse().forEach(function (_ref) {
                  var _ref2 = _slicedToArray(_ref, 2),
                      lhsIndex = _ref2[0],
                      rhsIndex = _ref2[1];

                  if (lhsIndex === null && rhsIndex !== null) {
                    var newNode = newTree.orderedNodes[rhsIndex];

                    if (newNode.parent !== undefined && correspondingNodes.newToOld[newNode.parent.index] !== undefined) {
                      newNode.node.inserted = true;
                    }
                  } else if (lhsIndex !== null && rhsIndex === null) {
                    var oldNode = oldTree.orderedNodes[lhsIndex];
                    var lhs = oldNode.node,
                        lastCommonAncestor = oldNode.parent;
                    lhs.deleted = true;
                    var correspondingAncestorIndex = correspondingNodes.oldToNew[lastCommonAncestor.index];

                    if (correspondingAncestorIndex === undefined) {
                      return;
                    } // Hide nested nodes that were moved out of this one rather than removed


                    var hideChanged = function hideChanged(node) {
                      if (correspondingNodes.oldToNew[node.index] !== undefined) {
                        node.node.hide = true;
                      }

                      node.children.forEach(hideChanged);
                    };

                    hideChanged(oldNode);
                    var previousNodeIndex;
                    var siblingNodes = lastCommonAncestor.children;

                    var _iterator = _createForOfIteratorHelper(siblingNodes),
                        _step;

                    try {
                      for (_iterator.s(); !(_step = _iterator.n()).done;) {
                        var sibling = _step.value;

                        if (sibling.index === lhsIndex) {
                          break;
                        } else {
                          var correspondingIndex = correspondingNodes.oldToNew[sibling.index];

                          if (correspondingIndex !== undefined) {
                            previousNodeIndex = correspondingIndex;
                          }
                        }
                      }
                    } catch (err) {
                      _iterator.e(err);
                    } finally {
                      _iterator.f();
                    }

                    var correspondingAncestor = newTree.orderedNodes[correspondingAncestorIndex];

                    if (previousNodeIndex !== undefined) {
                      var previousNode = newTree.orderedNodes[previousNodeIndex];
                      var insertIndex = correspondingAncestor.children.filter(function (child) {
                        return child.index <= previousNode.index;
                      }).length;
                      correspondingAncestor.node.children.splice(insertIndex, 0, lhs);
                    } else {
                      _this2.prependNode(correspondingAncestor.node, lhs);
                    }
                  } else if (lhsIndex !== null && rhsIndex !== null) {
                    var _lhs = oldTree.orderedNodes[lhsIndex].node;
                    var rhs = newTree.orderedNodes[rhsIndex].node;
                    rhs.changed = true;

                    if (_lhs.tag === rhs.tag && _lhs.inline && rhs.inline && JSON.stringify(_lhs.attrs) === JSON.stringify(rhs.attrs)) {
                      rhs.oldContent = _lhs.content;
                    } else {
                      rhs.replaces = _lhs;
                    }
                  }
                });
                _this2.diff = newTree.root.node;

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    prependNode: function prependNode(parent, node) {
      if (!parent.inline) {
        parent.children.unshift(node);
      } else {
        var contentNode = _objectSpread2({}, parent);

        contentNode.tag = 'SPAN';
        parent.inline = false;
        parent.children = [node, contentNode];
        delete parent.content;
      }
    },
    buildTree: function buildTree(root) {
      var self = this;

      function transformNode(node) {
        if (node.nodeType === Node.COMMENT_NODE) {
          return [];
        }

        if (node.nodeType === Node.TEXT_NODE && node.textContent.match(/^\s+$/)) {
          return [];
        }

        if (node.nodeType === Node.TEXT_NODE) {
          return [{
            tag: node.nodeName,
            inline: true,
            content: node.textContent.trim(),
            attrs: {}
          }];
        }

        var attrs = {};
        var attributes = node.attributes;

        if (attributes !== undefined) {
          for (var i = 0; i < attributes.length; i++) {
            attrs[attributes[i].name] = attributes[i].value;
          }
        }

        if (node.nodeName === 'LI') {
          var childLists = node.querySelectorAll('ul, ol');

          if (childLists.length === 0) {
            return [{
              tag: node.nodeName,
              children: [{
                tag: 'SPAN',
                inline: true,
                content: node.innerHTML.trim()
              }],
              attrs: attrs
            }];
          }

          var children = [];
          var lastList = null;
          childLists.forEach(function (list) {
            if (list.parentNode !== node) {
              return;
            }

            var span = document.createElement('span');
            var element = list.previousSibling;

            while (element !== lastList) {
              var nextElement = element.previousSibling;
              span.appendChild(element);
              element = nextElement;
            }

            if (span.childNodes.length > 0) {
              children.push.apply(children, _toConsumableArray(transformNode(span)));
            }

            children.push.apply(children, _toConsumableArray(transformNode(list)));
            lastList = list;
          });
          var span = document.createElement('span');
          var element = lastList.nextSibling;

          while (element !== null) {
            var nextElement = element.nextSibling;
            span.appendChild(element);
            element = nextElement;
          }

          if (span.childNodes.length > 0) {
            children.push.apply(children, _toConsumableArray(transformNode(span)));
          }

          return [{
            tag: 'LI',
            children: children,
            attrs: attrs
          }];
        }

        if (!self.blockTags.includes(node.nodeName.toLowerCase())) {
          return [{
            tag: node.nodeName,
            inline: true,
            content: (node.innerHTML || node.textContent).trim(),
            attrs: attrs
          }];
        }

        return [{
          tag: node.nodeName,
          children: Array.from(node.childNodes).flatMap(transformNode),
          attrs: attrs
        }];
      }

      return transformNode(root)[0];
    }
  }
};

var Edits = {
  EQUAL: DIFF_EQUAL,
  INSERT: DIFF_INSERT,
  DELETE: DIFF_DELETE
};
var LibraryModule = {
  LinearDiff: LinearDiff,
  TreeDiff: TreeDiff,
  install: function install(Vue) {
    Vue.component('linear-diff', LinearDiff);
    Vue.component('tree-diff', TreeDiff);
  }
};

exports.Edits = Edits;
exports.LinearDiff = LinearDiff;
exports.LinearDiffer = LinearDiffer;
exports.Tree = Tree;
exports.TreeDiff = TreeDiff;
exports.TreeDiffer = Differ;
exports.TreeNode = TreeNode;
exports.default = LibraryModule;
